(********************************************************************
 * COPYRIGHT --  
 ********************************************************************
 * Program: VirtualAxis
 * File: VirtualAxis.st
 * Author: chenh
 * Created: February 14, 2016
 ********************************************************************
 * Implementation of program VirtualAxis
 ********************************************************************)

PROGRAM _INIT

(* TODO : Add your code here *)
	gVAxisRef[0] := ADR(gVAxis01);
	gVAxisRef[1] := ADR(gVAxis02);
	(* Reset all command, preset axis parameter *)
	FOR VAxIdx := 0 TO (AXIS_VIRTUAL_MAX_INDEX) BY 1 DO
		VAxisStep[VAxIdx] 					:= STATE_WAIT;//᲻Ҫϵ磬ֱӵSTATE_READYȴִ
						
//		gVAxis[VAxIdx].Command.Halt 				:= FALSE;
//		gVAxis[VAxIdx].Command.Home 				:= FALSE;
//		gVAxis[VAxIdx].Command.MoveAbsolute 		:= FALSE;
//		gVAxis[VAxIdx].Command.Power 				:= 1;
//		gVAxis[VAxIdx].Command.Stop 				:= FALSE;
//		gVAxis[VAxIdx].Command.MoveAdditive 		:= FALSE;
//		gVAxis[VAxIdx].Command.MoveVelocity 		:= FALSE;		
//		gVAxis[VAxIdx].Command.AutStartSlave		:= FALSE;
//		gVAxis[VAxIdx].Command.AutDisengageSlave	:= FALSE;
//		gVAxis[VAxIdx].Command.Signal1				:= FALSE;
//		gVAxis[VAxIdx].Command.Signal2				:= FALSE;
//		gVAxis[VAxIdx].Command.Signal3				:= FALSE;
//		gVAxis[VAxIdx].Command.Signal4				:= FALSE;
		
		brsmemset(ADR(gVAxis[VAxIdx].Command),0,SIZEOF(gVAxis[VAxIdx].Command));
		
		//˶ʼ
		pVAxisData ACCESS gVAxisRef[VAxIdx];
		//ģʽͲʼ
		IF(gVAxis[VAxIdx].Parameter.V_Home <= 0)THEN
			gVAxis[VAxIdx].Parameter.V_Home			:= 300;			//Ѱٶ(Ѱһе)Ĭ5rpm
		END_IF
		gVAxis[VAxIdx].Parameter.HomeMode := mcHOME_DIRECT;
		gVAxis[VAxIdx].Parameter.HomePosition := 0;
	
		//˶ʼ
		gVAxis[VAxIdx].Parameter.Direction 		:= mcPOSITIVE_DIR;

		IF(gVAxis[VAxIdx].Parameter.Velocity <= 0)THEN
			gVAxis[VAxIdx].Parameter.Velocity 		:= pVAxisData.move.basis.parameter.v_pos;   //ĬٶΪʼеٶ
		END_IF		
		IF(gVAxis[VAxIdx].Parameter.Acceleration <= 0)THEN
			gVAxis[VAxIdx].Parameter.Acceleration 	:= pVAxisData.move.basis.parameter.a1_pos;
		END_IF
		IF(gVAxis[VAxIdx].Parameter.Deceleration <= 0)THEN
			gVAxis[VAxIdx].Parameter.Deceleration 	:= pVAxisData.move.basis.parameter.a1_neg;
		END_IF
		IF(gVAxis[VAxIdx].Parameter.JogVelocity <=0) THEN
			gVAxis[VAxIdx].Parameter.JogVelocity 	:= pVAxisData.move.basis.parameter.v_pos/10;//JogٶΪٶȵ10%
		END_IF
		
		IF(gVAxis[VAxIdx].Parameter.V_Override <= 0.0)THEN
			gVAxis[VAxIdx].Parameter.V_Override 	:= UINT_TO_REAL(pVAxisData.move.basis.override.v)/10000;//ٶȱӵλͳһ
		END_IF
		IF(gVAxis[VAxIdx].Parameter.A_Override <= 0.0)THEN
			gVAxis[VAxIdx].Parameter.A_Override		:= UINT_TO_REAL(pVAxisData.move.basis.override.a)/10000;//ٶȱ
		END_IF
		
	END_FOR
	
	(*********** ͹߳ʼ趨***************************)
	//ͬѡͬĵ
	//brsstrcpy(ADR(gVAxis[0].Parameter.paraTableName[0]),ADR('motor_00'));
	//brsstrcpy(ADR(gVAxis[0].Parameter.paraTableName[1]),ADR('motor_01')));
	
	//ͬѡͬCamProfile趨index
	brsstrcpy(ADR(gVAxis[0].Parameter.camProfileName[0]),ADR('cam_film'));
	gVAxis[0].Parameter.camProfileIndex[0] :=1;//index 114
	//brsstrcpy(ADR(gVAxis[0].Parameter.camProfileName[1]),ADR('cam_film1'));
	//gVAxis[0].Parameter.camProfileIndex[1] :=2;
	
END_PROGRAM


PROGRAM _CYCLIC


(* TODO : Add your code here *)
	(*********** Loop over all axes ߼***************************)
	FOR VAxIdx := 0 TO (AXIS_VIRTUAL_MAX_INDEX) BY 1 DO
       		
		IF (gVAxisRef[VAxIdx] = 0) THEN
			RETURN;
		ELSE
			pVAxisData ACCESS gVAxisRef[VAxIdx];
		END_IF	
		
		//˶CamIn趨ᣬ޸ľͿˡ
		(***************************MC_CamTableSelect_0*********************************)
		MC_CamTableSelect_0[0].Master 				:= gVAxisRef[1];  	//ָ1Ϊ		
		(**************************MC_CamIn_0*******************************************)
		MC_CamIn_0[0].Master 						:= gVAxisRef[1]; 	//ָ1Ϊ
		gVAxis[0].Parameter.CamPara.MasterScaling 	:=1;				//ʵ޸
		gVAxis[0].Parameter.CamPara.SlaveScaling 	:=1;				//ʵ޸
		gVAxis[0].Parameter.CamPara.StartMode		:=mcDIRECT;			//7--mcDIRECT 0--mcABSOLUTE
		gVAxis[0].Parameter.CamPara.MasterOffset	:= 0;				//ʵ޸
		gVAxis[0].Parameter.CamPara.SlaveOffset		:= 0;				//ʵ޸
		
		(***************************************************************
		        Control Sequence
		***************************************************************)
		(* status information is read before the step sequencer to attain a shorter reaction time *)
		(************************** MC_READSTATUS ***************************)
		MC_ReadStatus_0[VAxIdx].Enable := NOT(MC_ReadStatus_0[VAxIdx].Error);
		MC_ReadStatus_0[VAxIdx].Axis := gVAxisRef[VAxIdx];
		MC_ReadStatus_0[VAxIdx]();
		gVAxis[VAxIdx].AxisState.Disabled             := MC_ReadStatus_0[VAxIdx].Disabled;
		gVAxis[VAxIdx].AxisState.StandStill           := MC_ReadStatus_0[VAxIdx].StandStill;
		gVAxis[VAxIdx].AxisState.Stopping             := MC_ReadStatus_0[VAxIdx].Stopping;
		gVAxis[VAxIdx].AxisState.Homing               := MC_ReadStatus_0[VAxIdx].Homing;
		gVAxis[VAxIdx].AxisState.DiscreteMotion       := MC_ReadStatus_0[VAxIdx].DiscreteMotion;
		gVAxis[VAxIdx].AxisState.ContinuousMotion     := MC_ReadStatus_0[VAxIdx].ContinuousMotion;
		gVAxis[VAxIdx].AxisState.SynchronizedMotion   := MC_ReadStatus_0[VAxIdx].SynchronizedMotion;
		gVAxis[VAxIdx].AxisState.ErrorStop            := MC_ReadStatus_0[VAxIdx].Errorstop;
    
		(********************** MC_BR_READDRIVESTATUS ***********************)
		MC_BR_ReadDriveStatus_0[VAxIdx].Enable := NOT(MC_BR_ReadDriveStatus_0[VAxIdx].Error);
		MC_BR_ReadDriveStatus_0[VAxIdx].Axis := gVAxisRef[VAxIdx];
		MC_BR_ReadDriveStatus_0[VAxIdx].AdrDriveStatus := ADR(gVAxis[VAxIdx].Status.DriveStatus);
		MC_BR_ReadDriveStatus_0[VAxIdx]();
    
		(********************* MC_READACTUALPOSITION ************************)
		MC_ReadActualPosition_0[VAxIdx].Enable := NOT(MC_ReadActualPosition_0[VAxIdx].Error);
		MC_ReadActualPosition_0[VAxIdx].Axis := gVAxisRef[VAxIdx];
		MC_ReadActualPosition_0[VAxIdx]();
		IF(MC_ReadActualPosition_0[VAxIdx].Valid = TRUE) THEN
			gVAxis[VAxIdx].Status.ActPosition := MC_ReadActualPosition_0[VAxIdx].Position;
		END_IF
    
		(********************* MC_READACTUALVELOCITY ************************)
		MC_ReadActualVelocity_0[VAxIdx].Enable := NOT(MC_ReadActualVelocity_0[VAxIdx].Error);
		MC_ReadActualVelocity_0[VAxIdx].Axis := gVAxisRef[VAxIdx];
		MC_ReadActualVelocity_0[VAxIdx]();
		IF(MC_ReadActualVelocity_0[VAxIdx].Valid = TRUE) THEN
			gVAxis[VAxIdx].Status.ActVelocity := MC_ReadActualVelocity_0[VAxIdx].Velocity;
		END_IF
    
		(************************ MC_READAXISERROR **********************)
		MC_ReadAxisError_0[VAxIdx].Enable := NOT(MC_ReadAxisError_0[VAxIdx].Error);
		MC_ReadAxisError_0[VAxIdx].Axis := gVAxisRef[VAxIdx];
		MC_ReadAxisError_0[VAxIdx].DataAddress := ADR(gVAxis[VAxIdx].Error.ErrorText);
		MC_ReadAxisError_0[VAxIdx].DataLength := SIZEOF(gVAxis[VAxIdx].Error.ErrorText);
		MC_ReadAxisError_0[VAxIdx].DataObjectName := 'acp10etxen';
		MC_ReadAxisError_0[VAxIdx]();
		
		
		
		(**************** CHECK FOR GENERAL AXIS ERROR ******************)
		IF ((MC_ReadAxisError_0[VAxIdx].AxisErrorID <> 0) AND (MC_ReadAxisError_0[VAxIdx].Valid = TRUE)) THEN
			VAxisStep[VAxIdx] := STATE_ERROR_AXIS;
		END_IF
		
		(* central monitoring of the stop command allows a shorter reaction time *)
		IF (gVAxis[VAxIdx].Command.Stop = TRUE) THEN
			//ֹͣ
			IF (gVAxis[VAxIdx].Command.Power = TRUE) THEN
				VAxisStep[VAxIdx]					:= STATE_STOP;
				(* reset all FB execute inputs we use *)
				MC_Home_0[VAxIdx].Execute 			:= FALSE;
				MC_Halt_0[VAxIdx].Execute 			:= FALSE;
				MC_Stop_0[VAxIdx].Execute 			:= FALSE;
				MC_MoveAbsolute_0[VAxIdx].Execute 	:= FALSE;
				MC_MoveAdditive_0[VAxIdx].Execute 	:= FALSE;
				MC_MoveVelocity_0[VAxIdx].Execute 	:= FALSE;
				//ӣ
				MC_BR_AutControl_0[VAxIdx].Enable 	:= FALSE;
				MC_BR_AutControl_0[VAxIdx].Start 	:= FALSE;
				MC_BR_AutControl_0[VAxIdx].Stop 		:= FALSE;
				MC_Reset_0[VAxIdx].Execute 			:= FALSE;
				
				MC_CamTableSelect_0[VAxIdx].Execute	:= 0;
				MC_CamIn_0[VAxIdx].Execute			:= 0;
				
				brsmemset(ADR(gVAxis[VAxIdx].Command),0,SIZEOF(gVAxis[VAxIdx].Command));
//				gVAxis[VAxIdx].Command.Stop 			:= FALSE;
//				gVAxis[VAxIdx].Command.MoveAbsolute 	:= FALSE;
//				gVAxis[VAxIdx].Command.Home 			:= FALSE;
//				gVAxis[VAxIdx].Command.MoveAdditive 	:= FALSE;
//				gVAxis[VAxIdx].Command.MoveVelocity 	:= FALSE;
//				gVAxis[VAxIdx].Command.MoveJogPos		:= FALSE;
//				gVAxis[VAxIdx].Command.MoveJogNeg		:= FALSE;
//				
//				gVAxis[VAxIdx].Command.AutStartSlave 	:= FALSE;
//				gVAxis[VAxIdx].Command.AutDisengageSlave:= FALSE;
//				gVAxis[VAxIdx].Command.Signal1 			:= FALSE;
//				gVAxis[VAxIdx].Command.Signal2 			:= FALSE;
//				gVAxis[VAxIdx].Command.Signal3 			:= FALSE;
//				gVAxis[VAxIdx].Command.Signal4 			:= FALSE;
//				
//				gVAxis[VAxIdx].Command.CamStart 	:= 0;
//				gVAxis[VAxIdx].Command.CamStop		:= 0;

			END_IF			
		END_IF
			
		CASE VAxisStep[VAxIdx] OF
			(****************************** WAIT ********************************)
			(* WAIT: Wait for power on command                                  *)
			STATE_WAIT:				
				(* reset all FB execute inputs *)
				MC_Home_0[VAxIdx].Execute 			:= FALSE;
				MC_Stop_0[VAxIdx].Execute 			:= FALSE;
				MC_Halt_0[VAxIdx].Execute 			:= FALSE;
				MC_MoveAbsolute_0[VAxIdx].Execute 	:= FALSE;
				MC_MoveVelocity_0[VAxIdx].Execute 	:= FALSE;
				MC_MoveAdditive_0[VAxIdx].Execute 	:= FALSE;
				//ӣ
				MC_ReadAxisError_0[VAxIdx].Acknowledge := FALSE;
				MC_Reset_0[VAxIdx].Execute 			:= FALSE;
				
				MC_BR_AutControl_0[VAxIdx].Enable 	:= FALSE;
				MC_BR_AutControl_0[VAxIdx].Start 	:= FALSE;
				MC_BR_AutControl_0[VAxIdx].Stop 		:= FALSE;
				MC_Reset_0[VAxIdx].Execute 			:= FALSE;
				
				brsmemset(ADR(gVAxis[VAxIdx].Command),0,SIZEOF(gVAxis[VAxIdx].Command));
//				(* reset user commands *)
//				gVAxis[VAxIdx].Command.Stop 			:= FALSE;
//				gVAxis[VAxIdx].Command.MoveAbsolute 	:= FALSE;
//				gVAxis[VAxIdx].Command.Home 			:= FALSE;
//				gVAxis[VAxIdx].Command.MoveAdditive 	:= FALSE;
//				gVAxis[VAxIdx].Command.MoveVelocity 	:= FALSE;
//				gVAxis[VAxIdx].Command.MoveJogPos		:= FALSE;
//				gVAxis[VAxIdx].Command.MoveJogNeg		:= FALSE;
//				
//				gVAxis[VAxIdx].Command.AutStartSlave 	:= FALSE;
//				gVAxis[VAxIdx].Command.AutDisengageSlave 	:= FALSE;
//				gVAxis[VAxIdx].Command.Signal1 	:= FALSE;
//				gVAxis[VAxIdx].Command.Signal2 	:= FALSE;
//				gVAxis[VAxIdx].Command.Signal3 	:= FALSE;
//				gVAxis[VAxIdx].Command.Signal4 	:= FALSE;
//				
//				gVAxis[VAxIdx].Command.CamStart 	:= 0;
//				gVAxis[VAxIdx].Command.CamStop		:= 0;
				
				gVAxis[VAxIdx].Error.ErrorID := 0;
				IF(gVAxis[VAxIdx].Status.DriveStatus.ControllerReady = 1) THEN
					VAxisStep[VAxIdx] := STATE_CHECK_POWER;
				END_IF
			//ŷᴦϵ£Ͷϵ磬״ϵʹλͨ
			STATE_CHECK_POWER:
				IF(gVAxis[VAxIdx].Status.DriveStatus.ControllerStatus = 1) THEN
					MC_Power_0[VAxIdx].Enable := 0;
				ELSIF(gVAxis[VAxIdx].Status.DriveStatus.ControllerStatus = 0) THEN
					VAxisStep[VAxIdx] := STATE_GLOBAL_INIT;
				END_IF
			STATE_GLOBAL_INIT:
				pVAxisData.move.basis.parameter.v_pos := gVAxis[VAxIdx].Parameter.Velocity;
				pVAxisData.move.basis.parameter.v_neg := gVAxis[VAxIdx].Parameter.Velocity;
				pVAxisData.move.basis.parameter.a1_pos:= gVAxis[VAxIdx].Parameter.Acceleration;
				pVAxisData.move.basis.parameter.a1_neg:= gVAxis[VAxIdx].Parameter.Deceleration;
				pVAxisData.move.basis.parameter.a2_pos:= gVAxis[VAxIdx].Parameter.Acceleration;
				pVAxisData.move.basis.parameter.a2_neg:= gVAxis[VAxIdx].Parameter.Deceleration;
				
				MC_BR_InitAxisPar_0[VAxIdx].Execute :=1;
				
				VAxisStep[VAxIdx] := STATE_WAIT_GLOBAL_INIT;
			STATE_WAIT_GLOBAL_INIT:
				IF(MC_BR_InitAxisPar_0[VAxIdx].Done)THEN
					MC_BR_InitAxisPar_0[VAxIdx].Execute :=0;
					VAxisStep[VAxIdx] := STATE_INIT_POWER_ON;
				END_IF	
				IF(MC_BR_InitAxisPar_0[VAxIdx].Error) THEN
					MC_BR_InitAxisPar_0[VAxIdx].Execute :=0;
					gVAxis[VAxIdx].Error.ErrorID := MC_BR_InitAxisPar_0[VAxIdx].ErrorID;
					VAxisStep[VAxIdx] := STATE_ERROR;
				END_IF
			
			(***************************** POWER ON ****************************)
			(* Switch axis controller on                                       *)
			(*ʵҪϵ磬ǺʵһMC_Power.StatusҲTRUEʱʵͳһ*)
			STATE_INIT_POWER_ON:			
				MC_Power_0[VAxIdx].Enable := TRUE;			
				IF (MC_Power_0[VAxIdx].Status = TRUE) THEN
					(* If power on ok -> go direct to homing *)	
					VAxisStep[VAxIdx] := STATE_HOME_DIRECT; 
				END_IF  
				(* if a power error occured switch off controller *)
				IF (MC_Power_0[VAxIdx].Error = TRUE) THEN
					MC_Power_0[VAxIdx].Enable := FALSE;
					gVAxis[VAxIdx].Error.ErrorID := MC_Power_0[VAxIdx].ErrorID;
					VAxisStep[VAxIdx] := STATE_ERROR;
				END_IF 
			STATE_HOME_DIRECT:
				MC_Home_0[VAxIdx].Position := 0;
				MC_Home_0[VAxIdx].HomingMode := mcHOME_DIRECT;
				MC_Home_0[VAxIdx].Execute := 1;
				IF (MC_Home_0[VAxIdx].Done = 1) THEN
					MC_Home_0[VAxIdx].Execute := 0;
					VAxisStep[VAxIdx] := STATE_READY;
				END_IF   
				(* if a homing error occured go to ready state *)
				IF (MC_Home_0[VAxIdx].Error = TRUE) THEN
					MC_Home_0[VAxIdx].Execute := FALSE;
					gVAxis[VAxIdx].Error.ErrorID := MC_Home_0[VAxIdx].ErrorID;
					VAxisStep[VAxIdx] := STATE_ERROR;
				END_IF

			(****************************** READY *******************************)
			(* Wait for Commands                                                *)
			STATE_READY: 
				IF (gVAxis[VAxIdx].Command.Home = TRUE) THEN
					gVAxis[VAxIdx].Command.Home := FALSE;
					VAxisStep[VAxIdx] := STATE_HOME;
				ELSIF (gVAxis[VAxIdx].Command.MoveJogPos = TRUE) THEN
					VAxisStep[VAxIdx] := STATE_JOG_POSITIVE;
				ELSIF (gVAxis[VAxIdx].Command.MoveJogNeg = TRUE) THEN
					VAxisStep[VAxIdx] := STATE_JOG_NEGATIVE;	
				ELSIF (gVAxis[VAxIdx].Command.MoveAbsolute = TRUE) THEN
					gVAxis[VAxIdx].Command.MoveAbsolute := FALSE;
					VAxisStep[VAxIdx] := STATE_MOVE_ABSOLUTE;
				ELSIF (gVAxis[VAxIdx].Command.MoveVelocity = TRUE) THEN
					gVAxis[VAxIdx].Command.MoveVelocity := FALSE;
					VAxisStep[VAxIdx] := STATE_MOVE_VELOCITY;
				ELSIF (gVAxis[VAxIdx].Command.MoveAdditive = TRUE) THEN
					gVAxis[VAxIdx].Command.MoveAdditive := FALSE;
					VAxisStep[VAxIdx] := STATE_MOVE_ADDITIVE;					
				ELSIF (gVAxis[VAxIdx].Command.Halt = TRUE) THEN
					gVAxis[VAxIdx].Command.Halt := FALSE;
					VAxisStep[VAxIdx] := STATE_HALT;
					
				ELSIF(gVAxis[VAxIdx].Command.AutCamInit=1)THEN
					gVAxis[VAxIdx].Command.AutCamInit :=0;
					gVAxis[VAxIdx].Status.AutCamInitOk :=0;
					VAxisStep[VAxIdx] := STATE_AUTOMAT_INIT;//͹߳ʼ
				ELSIF(gVAxis[VAxIdx].Command.AutStartSlave=1)THEN
					gVAxis[VAxIdx].Command.AutStartSlave :=0;
					VAxisStep[VAxIdx] := STATE_AUTOMAT_INIT;//͹
				ELSIF (gVAxis[VAxIdx].Command.AutDisengageSlave = TRUE) THEN
					gVAxis[VAxIdx].Command.AutDisengageSlave := FALSE;
					MC_BR_AutControl_0[VAxIdx].Start := FALSE;
					VAxisStep[VAxIdx] := STATE_AUTOMAT_STOP;//	
				ELSIF gVAxis[VAxIdx].Command.CamStart	 THEN
					gVAxis[VAxIdx].Command.CamStart :=0;
					VAxisStep[VAxIdx] := STATE_CAM_SELECT;
				ELSIF gVAxis[VAxIdx].Command.CamStop THEN
					gVAxis[VAxIdx].Command.CamStop := 0;
					IF(gVAxis[VAxIdx].AxisState.SynchronizedMotion= TRUE)THEN //ֻͬ˶
						VAxisStep[VAxIdx] := STATE_CAM_STOP;
					END_IF				
				END_IF
			(****************************** HOME ********************************)
			(* Start homing process                                             *)
			STATE_HOME:
				MC_Home_0[VAxIdx].Position := gVAxis[VAxIdx].Parameter.HomePosition;
				MC_Home_0[VAxIdx].HomingMode := gVAxis[VAxIdx].Parameter.HomeMode;
				MC_Home_0[VAxIdx].Execute := TRUE;
				IF (MC_Home_0[VAxIdx].Done = TRUE) THEN
					MC_Home_0[VAxIdx].Execute := FALSE;
					VAxisStep[VAxIdx] := STATE_READY;
				END_IF   
				(* if a homing error occured go to ready state *)
				IF (MC_Home_0[VAxIdx].Error = TRUE) THEN
					MC_Home_0[VAxIdx].Execute := FALSE;
					gVAxis[VAxIdx].Error.ErrorID := MC_Home_0[VAxIdx].ErrorID;
					VAxisStep[VAxIdx] := STATE_ERROR;
				END_IF
			(*************************** HALT MOVEMENT **************************)
			(* Stop the active movement                                         *)
			STATE_HALT:
				MC_Halt_0[VAxIdx].Deceleration := gVAxis[VAxIdx].Parameter.Deceleration;
				MC_Halt_0[VAxIdx].Execute := TRUE;
				IF (MC_Halt_0[VAxIdx].Done = TRUE) THEN
					MC_Halt_0[VAxIdx].Execute := FALSE;
					VAxisStep[VAxIdx] := STATE_READY;
				END_IF
    
				(* check if error occured *)
				IF (MC_Halt_0[VAxIdx].Error = TRUE)THEN
					MC_Halt_0[VAxIdx].Execute := FALSE;
					gVAxis[VAxIdx].Error.ErrorID := MC_Halt_0[VAxIdx].ErrorID;
					VAxisStep[VAxIdx] := STATE_ERROR;
				END_IF
      
			(*************************** STOP MOVEMENT **************************)   
			(* Stop movement as long as command is set                          *)
			STATE_STOP:
				MC_Stop_0[VAxIdx].Deceleration := gVAxis[VAxIdx].Parameter.Deceleration;
				MC_Stop_0[VAxIdx].Execute := TRUE;    
				(* if axis is stopped go to ready state *)
				IF ((MC_Stop_0[VAxIdx].Done = TRUE) AND (gVAxis[VAxIdx].Command.Stop = FALSE)) THEN
					MC_Stop_0[VAxIdx].Execute := FALSE;
					VAxisStep[VAxIdx] := STATE_READY;
				END_IF   
				(* check if error occured *)
				IF (MC_Stop_0[VAxIdx].Error = TRUE) THEN
					MC_Stop_0[VAxIdx].Execute := FALSE;
					gVAxis[VAxIdx].Error.ErrorID := MC_Stop_0[VAxIdx].ErrorID;
					VAxisStep[VAxIdx] := STATE_ERROR;
				END_IF				
				(* reset all pendig commands *)
				gVAxis[VAxIdx].Command.MoveAbsolute := FALSE;
				gVAxis[VAxIdx].Command.Home := FALSE;
				gVAxis[VAxIdx].Command.MoveAdditive := FALSE;
				gVAxis[VAxIdx].Command.MoveVelocity := FALSE;
				gVAxis[VAxIdx].Command.AutStartSlave 	:= FALSE;
				gVAxis[VAxIdx].Command.AutDisengageSlave 	:= FALSE;			
				gVAxis[VAxIdx].Command.MoveJogPos	:= FALSE;
				gVAxis[VAxIdx].Command.MoveJogNeg	:= FALSE;
				gVAxis[VAxIdx].Command.Signal1 	:= FALSE;
				gVAxis[VAxIdx].Command.Signal2 	:= FALSE;
				gVAxis[VAxIdx].Command.Signal3 	:= FALSE;
				gVAxis[VAxIdx].Command.Signal4 	:= FALSE;
			
			(******************** START JOG MOVEMENT POSITVE **********************)
			STATE_JOG_POSITIVE:  (* STATE: Start jog movement in positive direction *)
							
				MC_MoveVelocity_0[VAxIdx].Velocity      := gVAxis[VAxIdx].Parameter.JogVelocity;
				MC_MoveVelocity_0[VAxIdx].Acceleration  := gVAxis[VAxIdx].Parameter.Acceleration;
				MC_MoveVelocity_0[VAxIdx].Deceleration  := gVAxis[VAxIdx].Parameter.Deceleration;
				MC_MoveVelocity_0[VAxIdx].Direction     := mcPOSITIVE_DIR;
				MC_MoveVelocity_0[VAxIdx].Execute       := 1;
				
				IF (gVAxis[VAxIdx].Command.MoveJogPos = FALSE) THEN
					MC_MoveVelocity_0[VAxIdx].Execute := 0;
					VAxisStep[VAxIdx] := STATE_HALT;
				END_IF
				(* check if error occured *)
				IF (MC_MoveVelocity_0[VAxIdx].Error = TRUE) THEN
					MC_MoveVelocity_0[VAxIdx].Execute := FALSE;
					gVAxis[VAxIdx].Error.ErrorID := MC_MoveVelocity_0[VAxIdx].ErrorID;
					VAxisStep[VAxIdx] := STATE_ERROR;
				END_IF
				

			(******************** START JOG MOVEMENT NEGATIVE **********************)
			STATE_JOG_NEGATIVE:  (* STATE: Start jog movement in negative direction *)
				
				MC_MoveVelocity_0[VAxIdx].Velocity      := gVAxis[VAxIdx].Parameter.JogVelocity;
				MC_MoveVelocity_0[VAxIdx].Acceleration  := gVAxis[VAxIdx].Parameter.Acceleration;
				MC_MoveVelocity_0[VAxIdx].Deceleration  := gVAxis[VAxIdx].Parameter.Deceleration;
				MC_MoveVelocity_0[VAxIdx].Direction     := mcNEGATIVE_DIR;
				MC_MoveVelocity_0[VAxIdx].Execute       := 1;
				
				IF (gVAxis[VAxIdx].Command.MoveJogNeg = FALSE) THEN
					MC_MoveVelocity_0[VAxIdx].Execute := 0;
					VAxisStep[VAxIdx] := STATE_HALT;
				END_IF
				(* check if error occured *)
				IF (MC_MoveVelocity_0[VAxIdx].Error = TRUE)THEN
					MC_MoveVelocity_0[VAxIdx].Execute := FALSE;
					gVAxis[VAxIdx].Error.ErrorID := MC_MoveVelocity_0[VAxIdx].ErrorID;
					VAxisStep[VAxIdx] := STATE_ERROR;
				END_IF
				
			(********************* START ABSOLUTE MOVEMENT **********************)
			(* Start absolute movement                                          *)
			STATE_MOVE_ABSOLUTE:
				MC_MoveAbsolute_0[VAxIdx].Direction     := 0;
				MC_MoveAbsolute_0[VAxIdx].Position      := gVAxis[VAxIdx].Parameter.Position;
				MC_MoveAbsolute_0[VAxIdx].Velocity      := gVAxis[VAxIdx].Parameter.Velocity;
				MC_MoveAbsolute_0[VAxIdx].Acceleration  := gVAxis[VAxIdx].Parameter.Acceleration;
				MC_MoveAbsolute_0[VAxIdx].Deceleration  := gVAxis[VAxIdx].Parameter.Deceleration;
				MC_MoveAbsolute_0[VAxIdx].Direction     := gVAxis[VAxIdx].Parameter.Direction;
				MC_MoveAbsolute_0[VAxIdx].Execute       := 1;
    
				IF (gVAxis[VAxIdx].Command.Halt = TRUE) THEN
					gVAxis[VAxIdx].Command.Halt := 0;
					MC_MoveAbsolute_0[VAxIdx].Execute := 0;
					VAxisStep[VAxIdx] := STATE_HALT;
				ELSIF (MC_MoveAbsolute_0[VAxIdx].Done = TRUE) THEN
					MC_MoveAbsolute_0[VAxIdx].Execute := FALSE;
					VAxisStep[VAxIdx] := STATE_READY;
				END_IF
    
				IF (MC_MoveAbsolute_0[VAxIdx].Error = TRUE)THEN
					MC_MoveAbsolute_0[VAxIdx].Execute := FALSE;
					gVAxis[VAxIdx].Error.ErrorID := MC_MoveAbsolute_0[VAxIdx].ErrorID;
					VAxisStep[VAxIdx] := STATE_ERROR;
				END_IF
    
			(********************* START ABSOLUTE VELOCITY **********************)
			(* Start velocity movement                                          *)
			STATE_MOVE_VELOCITY:
				MC_MoveVelocity_0[VAxIdx].Velocity      := gVAxis[VAxIdx].Parameter.Velocity;
				MC_MoveVelocity_0[VAxIdx].Acceleration  := gVAxis[VAxIdx].Parameter.Acceleration;
				MC_MoveVelocity_0[VAxIdx].Deceleration  := gVAxis[VAxIdx].Parameter.Deceleration;
				MC_MoveVelocity_0[VAxIdx].Direction     := gVAxis[VAxIdx].Parameter.Direction;
				MC_MoveVelocity_0[VAxIdx].Execute       := 1;
    
				IF (gVAxis[VAxIdx].Command.Halt = TRUE) THEN
					gVAxis[VAxIdx].Command.Halt := 0;
					MC_MoveVelocity_0[VAxIdx].Execute := 0;
					VAxisStep[VAxIdx] := STATE_HALT;
				END_IF
    
				IF (MC_MoveVelocity_0[VAxIdx].Error = TRUE)THEN
					MC_MoveVelocity_0[VAxIdx].Execute := FALSE;
					gVAxis[VAxIdx].Error.ErrorID := MC_MoveVelocity_0[VAxIdx].ErrorID;
					VAxisStep[VAxIdx] := STATE_ERROR;
				END_IF
    
			(********************* START ADDITIVE MOVEMENT **********************)
			(* Start additive movement                                          *)
			STATE_MOVE_ADDITIVE:
				MC_MoveAdditive_0[VAxIdx].Distance      := gVAxis[VAxIdx].Parameter.Distance;
				MC_MoveAdditive_0[VAxIdx].Velocity      := gVAxis[VAxIdx].Parameter.Velocity;
				MC_MoveAdditive_0[VAxIdx].Acceleration  := gVAxis[VAxIdx].Parameter.Acceleration;
				MC_MoveAdditive_0[VAxIdx].Deceleration  := gVAxis[VAxIdx].Parameter.Deceleration;
				MC_MoveAdditive_0[VAxIdx].Execute       := 1;
    
				IF (gVAxis[VAxIdx].Command.Halt = TRUE) THEN
					gVAxis[VAxIdx].Command.Halt := 0;
					MC_MoveAdditive_0[VAxIdx].Execute := 0;
					VAxisStep[VAxIdx] := STATE_HALT;
				ELSIF (MC_MoveAdditive_0[VAxIdx].Done = TRUE) THEN
					MC_MoveAdditive_0[VAxIdx].Execute := FALSE;
					VAxisStep[VAxIdx] := STATE_READY;
				END_IF
    
				IF (MC_MoveAdditive_0[VAxIdx].Error = TRUE) THEN
					MC_MoveAdditive_0[VAxIdx].Execute := FALSE;
					gVAxis[VAxIdx].Error.ErrorID := MC_MoveAdditive_0[VAxIdx].ErrorID;
					VAxisStep[VAxIdx] := STATE_ERROR;
				END_IF
			
			STATE_AUTOMAT_INIT:				
				//AutData  ɼܳAtuomatData 				
				MC_BR_AutControl_0[VAxIdx].Enable 		:= 1;
				MC_BR_AutControl_0[VAxIdx].AdrAutData 	:= ADR(AutDataV[VAxIdx]);
				MC_BR_AutControl_0[VAxIdx].InitAutData 	:= 1;
		
				IF(MC_BR_AutControl_0[VAxIdx].AutDataInitialized=1)THEN
					MC_BR_AutControl_0[VAxIdx].InitAutData 	:= 0;
					gVAxis[VAxIdx].Status.AutCamInitOk :=1;
					VAxisStep[VAxIdx] := STATE_READY;
				END_IF				
				(*check if error occured *)
				IF (MC_BR_AutControl_0[VAxIdx].Error = TRUE ) THEN
					MC_BR_AutControl_0[VAxIdx].Enable := FALSE;
					MC_BR_AutControl_0[VAxIdx].Start := FALSE;
					MC_BR_AutControl_0[VAxIdx].InitAutData 	:= FALSE;
					gVAxis[VAxIdx].Error.ErrorID := MC_BR_AutControl_0[VAxIdx].ErrorID;
					VAxisStep[VAxIdx] := STATE_ERROR;
				END_IF
						
			STATE_AUTOMAT_START:
				MC_BR_AutControl_0[VAxIdx].Enable := TRUE;
				MC_BR_AutControl_0[VAxIdx].Start := TRUE;			
				(* wait for Automat stop *)
				IF (gVAxis[VAxIdx].Command.Stop = TRUE) THEN
					MC_BR_AutControl_0[VAxIdx].Enable := FALSE;
					MC_BR_AutControl_0[VAxIdx].Start := FALSE;
					VAxisStep[VAxIdx] := STATE_STOP;
				ELSIF (gVAxis[VAxIdx].Command.Halt = TRUE) THEN
					gVAxis[VAxIdx].Command.Halt := FALSE;
					MC_BR_AutControl_0[VAxIdx].Enable := FALSE;
					MC_BR_AutControl_0[VAxIdx].Start := FALSE;
					VAxisStep[VAxIdx] := STATE_HALT;
				ELSIF (MC_BR_AutControl_0[VAxIdx].Running = TRUE) THEN
					VAxisStep[VAxIdx] := STATE_READY;
				END_IF
				
				(* check if error occured *)
				IF (MC_BR_AutControl_0[VAxIdx].Error = TRUE) THEN
					MC_BR_AutControl_0[VAxIdx].Enable := FALSE;
					MC_BR_AutControl_0[VAxIdx].Start := FALSE;
					gVAxis[VAxIdx].Error.ErrorID := MC_BR_AutControl_0[VAxIdx].ErrorID;
					VAxisStep[VAxIdx] := STATE_ERROR;
				END_IF
			
			STATE_AUTOMAT_STOP:
				MC_BR_AutControl_0[VAxIdx].Deceleration := gVAxis[VAxIdx].Parameter.Deceleration;
				MC_BR_AutControl_0[VAxIdx].Stop := TRUE;
				(* check if automat is stopped *)
				IF (MC_BR_AutControl_0[VAxIdx].Running = FALSE) THEN
					MC_BR_AutControl_0[VAxIdx].Enable := FALSE;
					MC_BR_AutControl_0[VAxIdx].Stop := FALSE;
					VAxisStep[VAxIdx] := STATE_READY;
				END_IF
				(* check if error occured *)
				IF (MC_BR_AutControl_0[VAxIdx].Error = TRUE) THEN
					MC_BR_AutControl_0[VAxIdx].Enable := FALSE;
					MC_BR_AutControl_0[VAxIdx].Stop := FALSE;
					gVAxis[VAxIdx].Error.ErrorID := MC_BR_AutControl_0[VAxIdx].ErrorID;
					VAxisStep[VAxIdx] := STATE_ERROR;
				END_IF
			STATE_CAM_SELECT:
				brsstrcpy(ADR(MC_CamTableSelect_0[VAxIdx].CamTable),ADR(gVAxis[VAxIdx].Parameter.camProfileName[0]));
				MC_CamTableSelect_0[VAxIdx].Periodic := mcPERIODIC;
				MC_CamTableSelect_0[VAxIdx].Execute 	:= 1;
				
				IF MC_CamTableSelect_0[VAxIdx].Done = 1 THEN
					MC_CamTableSelect_0[VAxIdx].Execute 	:= 0;
					CamTableID[VAxIdx] :=MC_CamTableSelect_0[VAxIdx].CamTableID;
					VAxisStep[VAxIdx] := STATE_CAM_START;
				ELSIF MC_CamTableSelect_0[VAxIdx].Error = 1 THEN
					MC_CamTableSelect_0[VAxIdx].Execute 	:= 0;
					gVAxis[VAxIdx].Error.ErrorID :=MC_CamTableSelect_0[VAxIdx].ErrorID;
					VAxisStep[VAxIdx] := STATE_ERROR;
				END_IF
			STATE_CAM_START:
				MC_CamIn_0[VAxIdx].MasterOffset 	:= gVAxis[VAxIdx].Parameter.CamPara.MasterOffset;
				MC_CamIn_0[VAxIdx].SlaveOffset 		:= gVAxis[VAxIdx].Parameter.CamPara.SlaveOffset;
				MC_CamIn_0[VAxIdx].MasterScaling 	:= gVAxis[VAxIdx].Parameter.CamPara.MasterScaling;
				MC_CamIn_0[VAxIdx].SlaveScaling 	:= gVAxis[VAxIdx].Parameter.CamPara.SlaveScaling;
				MC_CamIn_0[VAxIdx].StartMode 		:= gVAxis[VAxIdx].Parameter.CamPara.StartMode;
				MC_CamIn_0[VAxIdx].CamTableID 		:= CamTableID[VAxIdx];
				MC_CamIn_0[VAxIdx].Execute       	:= 1;
			
				IF gVAxis[VAxIdx].Command.Halt = 1 THEN
					gVAxis[VAxIdx].Command.Halt 	:= 0;
					MC_CamIn_0[VAxIdx].Execute 		:= 0;
					VAxisStep[VAxIdx] 				:= STATE_HALT;
				ELSIF MC_CamIn_0[VAxIdx].InSync = 1 THEN
					MC_CamIn_0[VAxIdx].Execute 		:= 0;
					VAxisStep[VAxIdx] 				:= STATE_READY;
				END_IF
				
				IF MC_CamIn_0[VAxIdx].Error  = 1 THEN
					MC_CamIn_0[VAxIdx].Execute 		:= 0;
					gVAxis[VAxIdx].Error.ErrorID 	:= MC_CamIn_0[VAxIdx].ErrorID;
					VAxisStep[VAxIdx] 				:= STATE_ERROR;
				END_IF
			STATE_CAM_STOP:
				MC_CamOut_0[VAxIdx].Execute 		:= 1; 
				IF MC_CamOut_0[VAxIdx].Done = 1 THEN
					MC_CamOut_0[VAxIdx].Execute 	:= 0;
					VAxisStep[VAxIdx] 				:= STATE_READY;
				END_IF
			
				IF MC_CamOut_0[VAxIdx].Error = 1 THEN
					MC_CamOut_0[VAxIdx].Execute 	:= 0;
					gAxis[VAxIdx].Error.ErrorID 	:= MC_CamOut_0[VAxIdx].ErrorID;
					VAxisStep[VAxIdx] 				:= STATE_ERROR;
				END_IF
			STATE_WRITE_PARID:
			(******************** FB-ERROR OCCURED *************************)
			STATE_ERROR:  (* STATE: Error *)
				(* check if FB indicates an axis error *)
				IF (MC_ReadAxisError_0[VAxIdx].AxisErrorCount<>0) THEN
					VAxisStep[VAxIdx] := STATE_ERROR_AXIS;
				ELSE
				
					IF (gVAxis[VAxIdx].Command.ErrorAcknowledge = TRUE) THEN
						gVAxis[VAxIdx].Command.ErrorAcknowledge := FALSE;
						gVAxis[VAxIdx].Error.ErrorID := 0;
						(* reset axis if it is in axis state ErrorStop *)
						IF ((MC_ReadStatus_0[VAxIdx].Errorstop = TRUE) AND (MC_ReadStatus_0[VAxIdx].Valid = TRUE)) THEN
							VAxisStep[VAxIdx] := STATE_ERROR_RESET;
						ELSE
							VAxisStep[VAxIdx] := STATE_WAIT;
						END_IF
					END_IF
				END_IF
			STATE_ERROR_STOP:
				MC_Stop_0[VAxIdx].Deceleration := gVAxis[VAxIdx].Parameter.Deceleration;
				MC_Stop_0[VAxIdx].Execute := TRUE;    
				(* if axis is stopped go to ready state *)
				IF (MC_Stop_0[VAxIdx].Done = TRUE) THEN
					MC_Stop_0[VAxIdx].Execute := FALSE;
					VAxisStep[VAxIdx] := STATE_ERROR;
				END_IF   
				(* check if error occured *)
				IF (MC_Stop_0[VAxIdx].Error = TRUE) THEN
					MC_Stop_0[VAxIdx].Execute := FALSE;
					gVAxis[VAxIdx].Error.ErrorID := MC_Stop_0[VAxIdx].ErrorID;
					VAxisStep[VAxIdx] := STATE_ERROR;
				END_IF				
				(* reset all pendig commands *)
				gVAxis[VAxIdx].Command.MoveAbsolute := FALSE;
				gVAxis[VAxIdx].Command.Home := FALSE;
				gVAxis[VAxIdx].Command.MoveAdditive := FALSE;
				gVAxis[VAxIdx].Command.MoveVelocity := FALSE;
				gVAxis[VAxIdx].Command.AutStartSlave 	:= FALSE;
				gVAxis[VAxIdx].Command.AutDisengageSlave 	:= FALSE;			
				gVAxis[VAxIdx].Command.MoveJogPos	:= FALSE;
				gVAxis[VAxIdx].Command.MoveJogNeg	:= FALSE;
				gVAxis[VAxIdx].Command.Signal1 	:= FALSE;
				gVAxis[VAxIdx].Command.Signal2 	:= FALSE;
				gVAxis[VAxIdx].Command.Signal3 	:= FALSE;
				gVAxis[VAxIdx].Command.Signal4 	:= FALSE;
			(******************** AXIS-ERROR OCCURED *************************)
			STATE_ERROR_AXIS:  (* STATE: Axis Error *)
				IF (MC_ReadAxisError_0[VAxIdx].Valid = TRUE) THEN
					IF (MC_ReadAxisError_0[VAxIdx].AxisErrorID <> 0) THEN
						gVAxis[VAxIdx].Error.ErrorID := MC_ReadAxisError_0[VAxIdx].AxisErrorID;
					END_IF
					MC_ReadAxisError_0[VAxIdx].Acknowledge := FALSE;
				
					IF (gVAxis[VAxIdx].Command.ErrorAcknowledge = TRUE) THEN
						gVAxis[VAxIdx].Command.ErrorAcknowledge := FALSE;
						(* acknowledge axis error *)
						IF (MC_ReadAxisError_0[VAxIdx].AxisErrorID <> 0) THEN
							MC_ReadAxisError_0[VAxIdx].Acknowledge := TRUE;
						END_IF
					END_IF
					IF (MC_ReadAxisError_0[VAxIdx].AxisErrorCount = 0) THEN
						(* reset axis if it is in axis state ErrorStop *)
						gVAxis[VAxIdx].Error.ErrorID := 0;
						IF ((MC_ReadStatus_0[VAxIdx].Errorstop = TRUE) AND (MC_ReadStatus_0[VAxIdx].Valid = TRUE)) THEN
							VAxisStep[VAxIdx] := STATE_ERROR_RESET;
						ELSE
							VAxisStep[VAxIdx] := STATE_WAIT;
						END_IF
					END_IF
				END_IF

			(******************** RESET DONE *************************)
			STATE_ERROR_RESET:  (* STATE: Wait for reset done *)
				MC_Reset_0[VAxIdx].Execute := TRUE;
				(* reset MC_Power.Enable if this FB is in Error*)
				IF (MC_Power_0[VAxIdx].Error = TRUE) THEN
					MC_Power_0[VAxIdx].Enable := FALSE;
				END_IF
				IF(MC_Reset_0[VAxIdx].Done = TRUE)THEN
					MC_Reset_0[VAxIdx].Execute := FALSE;
					VAxisStep[VAxIdx] := STATE_WAIT;
				ELSIF(MC_Reset_0[VAxIdx].Error = TRUE) THEN
					MC_Reset_0[VAxIdx].Execute := FALSE;
					VAxisStep[VAxIdx] := STATE_ERROR;                    
				END_IF
		END_CASE
		(*********************** SEQUENCE END *******************************)
		
		
		
		(*********************************************************************
		FUNCTION Block Calls
		*********************************************************************)
	   
		(*************************** MC_POWER *******************************)
		MC_Power_0[VAxIdx].Axis := gVAxisRef[VAxIdx];
		MC_Power_0[VAxIdx]();
    
		(**************************** MC_HOME *******************************)
		MC_Home_0[VAxIdx].Axis := gVAxisRef[VAxIdx];
		MC_Home_0[VAxIdx]();
    
		(************************ MC_MOVEABSOLUTE ***************************)
		MC_MoveAbsolute_0[VAxIdx].Axis := gVAxisRef[VAxIdx];
		MC_MoveAbsolute_0[VAxIdx]();
		
		(********************** MC_MOVEADDITIVE *************************)
		MC_MoveAdditive_0[VAxIdx].Axis := gVAxisRef[VAxIdx];
		MC_MoveAdditive_0[VAxIdx]();

		(********************** MC_MOVEVELOCITY *************************)
		MC_MoveVelocity_0[VAxIdx].Axis := gVAxisRef[VAxIdx];
		MC_MoveVelocity_0[VAxIdx]();
		
		(**************************** MC_STOP *******************************)
		MC_Stop_0[VAxIdx].Axis := gVAxisRef[VAxIdx];
		MC_Stop_0[VAxIdx]();
    
		(****************************MC_HALT*********************************)
		MC_Halt_0[VAxIdx].Axis := gVAxisRef[VAxIdx];
		MC_Halt_0[VAxIdx]();
		
		(************************** MC_RESET ****************************)
		MC_Reset_0[VAxIdx].Axis := gVAxisRef[VAxIdx];
		MC_Reset_0[VAxIdx]();
		
		(****************************MC_BR_InitAxisPar*********************************)
		MC_BR_InitAxisPar_0[VAxIdx].Axis := gVAxisRef[VAxIdx];
		MC_BR_InitAxisPar_0[VAxIdx]();
		(***************************MC_CamTableSelect_0*********************************)
		MC_CamTableSelect_0[VAxIdx].Slave:= gVAxisRef[VAxIdx];
		MC_CamTableSelect_0[VAxIdx]();
		
		(**************************MC_CamIn_0*******************************************)
		MC_CamIn_0[VAxIdx].Slave := gVAxisRef[VAxIdx];
		MC_CamIn_0[VAxIdx]();
		
		(********************** MC_BR_AutControl*************************)
		MC_BR_AutControl_0[VAxIdx].Slave := gVAxisRef[VAxIdx];
		MC_BR_AutControl_0[VAxIdx].Signal1	:= gVAxis[VAxIdx].Command.Signal1;
		MC_BR_AutControl_0[VAxIdx].Signal2	:= gVAxis[VAxIdx].Command.Signal2;
		MC_BR_AutControl_0[VAxIdx].Signal3	:= gVAxis[VAxIdx].Command.Signal3;
		MC_BR_AutControl_0[VAxIdx].Signal4	:= gVAxis[VAxIdx].Command.Signal4;
		MC_BR_AutControl_0[VAxIdx]();
		gVAxis[VAxIdx].Status.ActualStateIndex := MC_BR_AutControl_0[VAxIdx].ActualStateIndex;
		
		
		//Ҫɾ
		(********************** MC_SetOverride*************************)
		MC_SetOverride_0[VAxIdx].Enable		:= NOT(MC_ReadStatus_0[VAxIdx].StandStill);
		MC_SetOverride_0[VAxIdx].VelFactor	:= gVAxis[VAxIdx].Parameter.V_Override;
		MC_SetOverride_0[VAxIdx].AccFactor	:= gVAxis[VAxIdx].Parameter.A_Override;
		MC_SetOverride_0[VAxIdx].Axis		:= gVAxisRef[VAxIdx];
		MC_SetOverride_0[VAxIdx]();
		
		
		
		
	END_FOR;

END_PROGRAM
