(********************************************************************
 * COPYRIGHT --  
 ********************************************************************
 * Program: RealAxis
 * File: RealAxis.st
 * Author: chenh
 * Created: February 14, 2016
 * changed by	2017.10.16
	1.CamIn    
	2.MultiԴж
	3.ÿϵԭķʽʵҪ޸ġ
		STATE_HOME_DIRECT
				MC_Home_0[AxIdx].Position 	:= 0;
				MC_Home_0[AxIdx].HomingMode := mcHOME_DIRECT;
				MC_Home_0[AxIdx].Execute 	:= TRUE;
	4.
 ********************************************************************
 * Implementation of program RealAxis
 ********************************************************************)


PROGRAM _INIT


(* TODO : Add your code here *)
	gAxisRef[0] := ADR(gAxis01);
	gAxisRef[1] := ADR(gAxis02);
	
	(* Reset all command, preset axis parameter *)
	FOR AxIdx := 0 TO (AXIS_REAL_MAX_INDEX) BY 1 DO
		
		AxisStep[AxIdx] 						:= STATE_WAIT;
				
//		gAxis[AxIdx].Command.Halt 				:= FALSE;
//		gAxis[AxIdx].Command.Home 				:= FALSE;
//		gAxis[AxIdx].Command.MoveAbsolute 		:= FALSE;
//		gAxis[AxIdx].Command.Power 				:= FALSE;
//		gAxis[AxIdx].Command.Stop 				:= FALSE;		
//		gAxis[AxIdx].Command.MoveJogPos 		:= FALSE;
//		gAxis[AxIdx].Command.MoveJogNeg 		:= FALSE;
//		gAxis[AxIdx].Command.MoveAdditive 		:= FALSE;
//		gAxis[AxIdx].Command.MoveVelocity 		:= FALSE;
//			
//		gAxis[AxIdx].Command.AutStartSlave		:= FALSE;
//		gAxis[AxIdx].Command.AutDisengageSlave	:= FALSE;
//		gAxis[AxIdx].Command.Signal1			:= FALSE;
//		gAxis[AxIdx].Command.Signal2			:= FALSE;
//		gAxis[AxIdx].Command.Signal3			:= FALSE;
//		gAxis[AxIdx].Command.Signal4			:= FALSE;
		brsmemset(ADR(gAxis[AxIdx].Command),0,SIZEOF(gAxis[AxIdx].Command));
		
		//ʵ˶ʼ
		pAxisData ACCESS gAxisRef[AxIdx];
		
		//ʵģʽͲʼ
		IF(gAxis[AxIdx].Parameter.V_Home <= 0)THEN
			gAxis[AxIdx].Parameter.V_Home	:= 300;			//Ѱٶ,ÿ᲻һ(Ѱһе)
		END_IF
		gAxis[AxIdx].Parameter.HomeMode := mcHOME_DIRECT;
		gAxis[AxIdx].Parameter.HomePosition := 0;
		
		gAxis[AxIdx].Parameter.Direction 			:= mcPOSITIVE_DIR;
		IF(gAxis[AxIdx].Parameter.Velocity <= 0)THEN
			gAxis[AxIdx].Parameter.Velocity 		:= pAxisData.move.basis.parameter.v_pos;   		//Ĭٶ10rpm
		END_IF		
		IF(gAxis[AxIdx].Parameter.Acceleration <= 0)THEN
			gAxis[AxIdx].Parameter.Acceleration 	:= pAxisData.move.basis.parameter.a1_pos;
		END_IF
		IF(gAxis[AxIdx].Parameter.Deceleration <= 0)THEN
			gAxis[AxIdx].Parameter.Deceleration 	:= pAxisData.move.basis.parameter.a1_neg;
		END_IF
		IF(gAxis[AxIdx].Parameter.JogVelocity <= 0) THEN
			gAxis[AxIdx].Parameter.JogVelocity		:= pAxisData.move.basis.parameter.v_pos/10;//Ϊٶȵ10%
		END_IF		
		IF(gAxis[AxIdx].Parameter.V_Override <= 0.0)THEN
			gAxis[AxIdx].Parameter.V_Override 		:= UINT_TO_REAL(pAxisData.move.basis.override.v)/10000;
		END_IF
		IF(gAxis[AxIdx].Parameter.A_Override <= 0.0)THEN
			gAxis[AxIdx].Parameter.A_Override		:= UINT_TO_REAL(pAxisData.move.basis.override.a)/10000;;
		END_IF
		
		
		//ĳʼ
		IF(gAxis[AxIdx].Parameter.EncoderPara.units <= 0)THEN
			gAxis[AxIdx].Parameter.EncoderPara.units:= pAxisData.encoder_if.parameter.scaling.load.units;
		END_IF		
		IF(gAxis[AxIdx].Parameter.EncoderPara.rev_motor<=0) THEN
			gAxis[AxIdx].Parameter.EncoderPara.rev_motor :=pAxisData.encoder_if.parameter.scaling.load.rev_motor;
		END_IF
		gAxis[AxIdx].Parameter.EncoderPara.count_dir :=pAxisData.encoder_if.parameter.count_dir;
		
		//ʼ,ҪĲģʽ
		IF(gAxis[AxIdx].Parameter.Control.Kpp <= 0.0) THEN 
				gAxis[AxIdx].Parameter.Control.Kpp := pAxisData.controller.position.kv;
		END_IF
		IF(gAxis[AxIdx].Parameter.Control.Kvp <=0.0) THEN
				gAxis[AxIdx].Parameter.Control.Kvp := pAxisData.controller.speed.kv;
		END_IF
			
	END_FOR
	
	(*********** ͹߳ʼ趨***************************)
	//ͬѡͬĵ
	//brsstrcpy(ADR(gAxis[0].Parameter.paraTableName[0]),ADR('motor_00'));
	//brsstrcpy(ADR(gAxis[0].Parameter.paraTableName[1]),ADR('motor_01')));
	
	//ͬѡͬCamProfile趨index
	brsstrcpy(ADR(gAxis[0].Parameter.camProfileName[0]),ADR('cam_film'));
	gAxis[0].Parameter.camProfileIndex[0] :=1;//index 114
	//brsstrcpy(ADR(gAxis[0].Parameter.camProfileName[1]),ADR('cam_film1'));
	//gAxis[0].Parameter.camProfileIndex[1] :=2;
	
	
END_PROGRAM


PROGRAM _CYCLIC

(* TODO : Add your code here *)
	//˶CamIn趨ᣬ޸ľͿˡ
	(***************************MC_CamTableSelect_0*********************************)
	MC_CamTableSelect_0[0].Master 				:= gAxisRef[1];  	//ָ1Ϊ		
	(**************************MC_CamIn_0*******************************************)
	MC_CamIn_0[0].Master 						:= gAxisRef[1]; 	//ָ1Ϊ
	gAxis[0].Parameter.CamPara.MasterScaling 	:=1;				//ʵ޸
	gAxis[0].Parameter.CamPara.SlaveScaling 	:=1;				//ʵ޸
	gAxis[0].Parameter.CamPara.StartMode		:=mcDIRECT;			//7--mcDIRECT 0--mcABSOLUTE
	gAxis[0].Parameter.CamPara.MasterOffset		:= 0;				//ʵ޸
	gAxis[0].Parameter.CamPara.SlaveOffset		:= 0;				//ʵ޸
	
	(*********** Loop over all axes ߼***************************)
	FOR AxIdx := 0 TO (AXIS_REAL_MAX_INDEX) BY 1 DO
       	
		//ȡָ̬
		IF(gAxisRef[AxIdx]=0)THEN
			RETURN;
		ELSE
			pAxisData ACCESS gAxisRef[AxIdx];
		END_IF
		
		(***************************************************************
		        Control Sequence
		***************************************************************)
		(* status information is read before the step sequencer to attain a shorter reaction time *)
		(************************** MC_READSTATUS ***************************)
		MC_ReadStatus_0[AxIdx].Enable 				:= NOT(MC_ReadStatus_0[AxIdx].Error);
		MC_ReadStatus_0[AxIdx].Axis 				:= gAxisRef[AxIdx];
		MC_ReadStatus_0[AxIdx]();
		gAxis[AxIdx].AxisState.Disabled             := MC_ReadStatus_0[AxIdx].Disabled;
		gAxis[AxIdx].AxisState.StandStill           := MC_ReadStatus_0[AxIdx].StandStill;
		gAxis[AxIdx].AxisState.Stopping             := MC_ReadStatus_0[AxIdx].Stopping;
		gAxis[AxIdx].AxisState.Homing               := MC_ReadStatus_0[AxIdx].Homing;
		gAxis[AxIdx].AxisState.DiscreteMotion       := MC_ReadStatus_0[AxIdx].DiscreteMotion;
		gAxis[AxIdx].AxisState.ContinuousMotion     := MC_ReadStatus_0[AxIdx].ContinuousMotion;
		gAxis[AxIdx].AxisState.SynchronizedMotion   := MC_ReadStatus_0[AxIdx].SynchronizedMotion;
		gAxis[AxIdx].AxisState.ErrorStop            := MC_ReadStatus_0[AxIdx].Errorstop;
    
		(********************** MC_BR_READDRIVESTATUS ***********************)
		MC_BR_ReadDriveStatus_0[AxIdx].Enable 		:= NOT(MC_BR_ReadDriveStatus_0[AxIdx].Error);
		MC_BR_ReadDriveStatus_0[AxIdx].Axis 		:= gAxisRef[AxIdx];
		MC_BR_ReadDriveStatus_0[AxIdx].AdrDriveStatus := ADR(gAxis[AxIdx].Status.DriveStatus);
		MC_BR_ReadDriveStatus_0[AxIdx]();
    
		(********************* MC_READACTUALPOSITION ************************)
		MC_ReadActualPosition_0[AxIdx].Enable 		:= NOT(MC_ReadActualPosition_0[AxIdx].Error);
		MC_ReadActualPosition_0[AxIdx].Axis 		:= gAxisRef[AxIdx];
		MC_ReadActualPosition_0[AxIdx]();
		IF(MC_ReadActualPosition_0[AxIdx].Valid = TRUE) THEN
			gAxis[AxIdx].Status.ActPosition 		:= MC_ReadActualPosition_0[AxIdx].Position;
		END_IF
    
		(********************* MC_READACTUALVELOCITY ************************)
		MC_ReadActualVelocity_0[AxIdx].Enable 		:= NOT(MC_ReadActualVelocity_0[AxIdx].Error);
		MC_ReadActualVelocity_0[AxIdx].Axis 		:= gAxisRef[AxIdx];
		MC_ReadActualVelocity_0[AxIdx]();
		IF(MC_ReadActualVelocity_0[AxIdx].Valid = TRUE) THEN
			gAxis[AxIdx].Status.ActVelocity 		:= MC_ReadActualVelocity_0[AxIdx].Velocity;
			gAxis[AxIdx].Status.ActRpm				:= gAxis[AxIdx].Status.ActVelocity/60;//ʵתʵʵת
		END_IF
    
		(********************* MC_ReadActualTorque ************************)
		//ֻʵſԶȡŤ
		MC_ReadActualTorque_0[AxIdx].Enable 		:= NOT(MC_ReadActualTorque_0[AxIdx].Error);
		MC_ReadActualTorque_0[AxIdx].Axis 			:= gAxisRef[AxIdx];
		MC_ReadActualTorque_0[AxIdx]();
		IF(MC_ReadActualTorque_0[AxIdx].Valid = TRUE) THEN
			gAxis[AxIdx].Status.ActTorque 			:= MC_ReadActualTorque_0[AxIdx].Torque;
		END_IF
		
		(************************ MC_READAXISERROR **********************)
		MC_ReadAxisError_0[AxIdx].Enable 			:= NOT(MC_ReadAxisError_0[AxIdx].Error);
		MC_ReadAxisError_0[AxIdx].Axis 				:= gAxisRef[AxIdx];
		MC_ReadAxisError_0[AxIdx].DataAddress 		:= ADR(gAxis[AxIdx].Error.ErrorText);
		MC_ReadAxisError_0[AxIdx].DataLength 		:= SIZEOF(gAxis[AxIdx].Error.ErrorText);
		MC_ReadAxisError_0[AxIdx].DataObjectName 	:= 'acp10etxen';
		MC_ReadAxisError_0[AxIdx]();
		
		(**************** CHECK FOR GENERAL AXIS ERROR ******************)
		IF ((MC_ReadAxisError_0[AxIdx].AxisErrorID <> 0) AND (MC_ReadAxisError_0[AxIdx].Valid = TRUE)) THEN
			AxisStep[AxIdx] := STATE_ERROR_AXIS;
			(***************** CHECK IF POWER SHOULD BE OFF *******************)
		END_IF
			
		(* central monitoring of the stop command allows a shorter reaction time *)
		IF (gAxis[AxIdx].Command.Stop = TRUE)THEN
			//ʵֹͣ
			IF (gAxis[AxIdx].Status.DriveStatus.ControllerStatus = TRUE) THEN
				AxisStep[AxIdx]						:= STATE_STOP;
				(* reset all FB execute inputs we use *)
				MC_Home_0[AxIdx].Execute 			:= FALSE;
				MC_Halt_0[AxIdx].Execute 			:= FALSE;
				MC_Stop_0[AxIdx].Execute 			:= FALSE;
				MC_MoveAbsolute_0[AxIdx].Execute 	:= FALSE;
				MC_MoveAdditive_0[AxIdx].Execute 	:= FALSE;
				MC_MoveVelocity_0[AxIdx].Execute 	:= FALSE;
				//ӣ
				MC_Reset_0[AxIdx].Execute 			:= FALSE;
				MC_BR_AutControl_0[AxIdx].Enable 	:= FALSE;
				MC_BR_AutControl_0[AxIdx].Start 	:= FALSE;
				MC_BR_AutControl_0[AxIdx].Stop 		:= FALSE;
				//ӹܿö˸λ 20171020
				MC_CamTableSelect_0[AxIdx].Execute	:= 0;
				MC_CamIn_0[AxIdx].Execute			:= 0;
				brsmemset(ADR(gAxis[AxIdx].Command),0,SIZEOF(gAxis[AxIdx].Command));
//				gAxis[AxIdx].Command.Stop 			:= FALSE;
//				gAxis[AxIdx].Command.MoveAbsolute 	:= FALSE;
//				gAxis[AxIdx].Command.Home 			:= FALSE;
//				gAxis[AxIdx].Command.MoveAdditive 	:= FALSE;
//				gAxis[AxIdx].Command.MoveVelocity 	:= FALSE;
//				gAxis[AxIdx].Command.MoveJogPos 	:= FALSE;
//				gAxis[AxIdx].Command.MoveJogNeg 	:= FALSE;
//				gAxis[AxIdx].Command.resetGlobalInit := FALSE;
//				
//				gAxis[AxIdx].Command.AutCamInit		:= FALSE;
//				gAxis[AxIdx].Command.AutStartSlave 	:= FALSE;
//				gAxis[AxIdx].Command.AutDisengageSlave := FALSE;			
//				gAxis[AxIdx].Command.Signal1 		:= FALSE;
//				gAxis[AxIdx].Command.Signal2 		:= FALSE;
//				gAxis[AxIdx].Command.Signal3 		:= FALSE;
//				gAxis[AxIdx].Command.Signal4 		:= FALSE;
//				//ӹλ20171020
//				gAxis[AxIdx].Command.CamStart		:= 0;//λ
//				gAxis[AxIdx].Command.CamStop		:= 0;
			END_IF			
		END_IF
		CASE AxisStep[AxIdx] OF
			(****************************** STATE_WAIT_INIT ********************************)
		
			(* WAIT: Wait for ControllerReady *)
			STATE_WAIT:				
				(* reset all FB execute inputs *)
				MC_Home_0[AxIdx].Execute 			:= FALSE;
				MC_Stop_0[AxIdx].Execute 			:= FALSE;
				MC_Halt_0[AxIdx].Execute 			:= FALSE;
				MC_MoveAbsolute_0[AxIdx].Execute 	:= FALSE;
				MC_MoveVelocity_0[AxIdx].Execute 	:= FALSE;
				MC_MoveAdditive_0[AxIdx].Execute 	:= FALSE;
				MC_ReadAxisError_0[AxIdx].Acknowledge := FALSE;
				MC_Reset_0[AxIdx].Execute 			:= FALSE;
				
				MC_BR_InitParTabObj_0[AxIdx].Execute 			:= FALSE;
				MC_BR_DownloadCamProfileObj_0[AxIdx].Execute 	:= FALSE;
				MC_BR_InitAxisPar_0[AxIdx].Execute 				:= FALSE;
				//ӣ
				MC_BR_AutControl_0[AxIdx].Enable 	:= FALSE;
				MC_BR_AutControl_0[AxIdx].Start 	:= FALSE;
				MC_BR_AutControl_0[AxIdx].Stop 		:= FALSE;
				MC_CamTableSelect_0[AxIdx].Execute	:= 0;
				MC_CamIn_0[AxIdx].Execute			:= 0;
				(* reset user commands *)
				brsmemset(ADR(gAxis[AxIdx].Command),0,SIZEOF(gAxis[AxIdx].Command));
//				gAxis[AxIdx].Command.Stop 			:= FALSE;
//				gAxis[AxIdx].Command.MoveAbsolute 	:= FALSE;
//				gAxis[AxIdx].Command.Home 			:= FALSE;
//				gAxis[AxIdx].Command.MoveAdditive 	:= FALSE;
//				gAxis[AxIdx].Command.MoveVelocity 	:= FALSE;
//				gAxis[AxIdx].Command.MoveJogPos 	:= FALSE;
//				gAxis[AxIdx].Command.MoveJogNeg 	:= FALSE;
//				gAxis[AxIdx].Command.resetGlobalInit := FALSE;
//				
//				gAxis[AxIdx].Command.AutCamInit		:= FALSE;
//				gAxis[AxIdx].Command.AutStartSlave 	:= FALSE;
//				gAxis[AxIdx].Command.AutDisengageSlave := FALSE;			
//				gAxis[AxIdx].Command.Signal1 		:= FALSE;
//				gAxis[AxIdx].Command.Signal2 		:= FALSE;
//				gAxis[AxIdx].Command.Signal3 		:= FALSE;
//				gAxis[AxIdx].Command.Signal4 		:= FALSE;
//				
//				gAxis[AxIdx].Command.CamStart		:= 0;//λ
//				gAxis[AxIdx].Command.CamStop		:= 0;
				gAxis[AxIdx].Error.ErrorID := 0;
				//ȴREADY,ûд
				
				IF(gAxis[AxIdx].Status.DriveStatus.ControllerReady = 1)THEN
					AxisStep[AxIdx] := STATE_DOWNLOAD_CAM_PROFILE;
				END_IF
			(***************************** MC_BR_DownloadCamProfileObj ****************************)
			//ʼÿᶨ͹(ʱԶ5)			
			STATE_DOWNLOAD_CAM_PROFILE:
								
				IF(gAxis[AxIdx].Status.camProfDownInitOk = 1)THEN
					CamProfileIndex[AxIdx] :=0;
					AxisStep[AxIdx] := STATE_DOWNLOAD_PARA_TABLE;//ִйʼִ
				ELSIF(brsstrlen(ADR(gAxis[AxIdx].Parameter.camProfileName[CamProfileIndex[AxIdx]]))=0)THEN
					CamProfileIndex[AxIdx] :=0;
					gAxis[AxIdx].Status.camProfDownInitOk :=1;
					AxisStep[AxIdx] := STATE_DOWNLOAD_PARA_TABLE;//ûֲִ
					
				ELSE
					brsstrcpy(ADR(MC_BR_DownloadCamProfileObj_0[AxIdx].DataObjectName),ADR(gAxis[AxIdx].Parameter.camProfileName[CamProfileIndex[AxIdx]]));
					MC_BR_DownloadCamProfileObj_0[AxIdx].Index := gAxis[AxIdx].Parameter.camProfileIndex[CamProfileIndex[AxIdx]];//CamTableID
					MC_BR_DownloadCamProfileObj_0[AxIdx].Periodic := mcNON_PERIODIC;
					MC_BR_DownloadCamProfileObj_0[AxIdx].Execute := 1;
					AxisStep[AxIdx] := STATE_WAIT_DOWNLOAD_CAM_PROFILE;
				END_IF
					
			STATE_WAIT_DOWNLOAD_CAM_PROFILE:
				IF(MC_BR_DownloadCamProfileObj_0[AxIdx].Done=1)THEN
					MC_BR_DownloadCamProfileObj_0[AxIdx].Execute :=0;
					CamProfileIndex[AxIdx] :=CamProfileIndex[AxIdx]+1;
					IF(CamProfileIndex[AxIdx]<MAX_AXIS_DB_NUM)THEN
						AxisStep[AxIdx] := STATE_DOWNLOAD_CAM_PROFILE;		//һ͹
					ELSE
						CamProfileIndex[AxIdx] :=0;
						gAxis[AxIdx].Status.camProfDownInitOk :=1;
						AxisStep[AxIdx] := STATE_DOWNLOAD_PARA_TABLE;		//͹						
					END_IF					
				END_IF
				
				IF(MC_BR_DownloadCamProfileObj_0[AxIdx].Error=1)THEN
					MC_BR_DownloadCamProfileObj_0[AxIdx].Execute :=0;
					gAxis[AxIdx].Status.camProfDownInitOk :=0;
					gAxis[AxIdx].Error.ErrorID := MC_BR_DownloadCamProfileObj_0[AxIdx].ErrorID;
					AxisStep[AxIdx] := STATE_ERROR;
				END_IF
			(***************************** MC_BR_InitParTabObj ****************************)
			//ʼÿᶨĲ(ʱԶ5޸MAX_AXIS_DB_NUM)
			STATE_DOWNLOAD_PARA_TABLE:								
				IF(gAxis[AxIdx].Status.paraTabDownInitOk=1)THEN
					ParaTableIndex[AxIdx] := 0;	
//					AxisStep[AxIdx] := STATE_GLOBAL_INIT;//ִйʼִ
					AxisStep[AxIdx] := STATE_CHECK_POWER; //״̬ǷҪϵ
					CamProfileIndex[AxIdx] :=0;
				ELSIF( brsstrlen(ADR(gAxis[AxIdx].Parameter.paraTableName[ParaTableIndex[AxIdx]]))=0 )THEN
					ParaTableIndex[AxIdx] := 0;	
					gAxis[AxIdx].Status.paraTabDownInitOk :=1;
//					AxisStep[AxIdx] := STATE_GLOBAL_INIT;//ûֲִ
					AxisStep[AxIdx] := STATE_CHECK_POWER;//״̬
					CamProfileIndex[AxIdx] :=0;
				ELSE
					brsstrcpy(ADR(MC_BR_InitParTabObj_0[AxIdx].DataObjectName),ADR(gAxis[AxIdx].Parameter.paraTableName[ParaTableIndex[AxIdx]]));
					MC_BR_InitParTabObj_0[AxIdx].Execute :=1;
					AxisStep[AxIdx] := STATE_WAIT_DOWNLOAD_PARA_TABLE;
				END_IF
			
			STATE_WAIT_DOWNLOAD_PARA_TABLE:
				IF(MC_BR_InitParTabObj_0[AxIdx].Done =1)THEN
					MC_BR_InitParTabObj_0[AxIdx].Execute :=0;
					ParaTableIndex[AxIdx] :=ParaTableIndex[AxIdx]+1;
					IF(ParaTableIndex[AxIdx]<MAX_AXIS_DB_NUM)THEN
						AxisStep[AxIdx] := STATE_DOWNLOAD_PARA_TABLE;//رһ
					ELSE
						ParaTableIndex[AxIdx] := 0;	
						gAxis[AxIdx].Status.paraTabDownInitOk :=1;
						AxisStep[AxIdx] := STATE_GLOBAL_INIT;//в
						CamProfileIndex[AxIdx] :=0;
					END_IF					
				END_IF
				IF(MC_BR_InitParTabObj_0[AxIdx].Error=1)THEN
					MC_BR_InitParTabObj_0[AxIdx].Execute :=0;
					gAxis[AxIdx].Status.paraTabDownInitOk :=0;
					gAxis[AxIdx].Error.ErrorID := MC_BR_InitParTabObj_0[AxIdx].ErrorID;
					AxisStep[AxIdx] := STATE_ERROR;
				END_IF	
			//ŷᴦϵ£Ͷϵ磬״ϵʹλͨ
			STATE_CHECK_POWER:
				IF(gAxis[AxIdx].Status.DriveStatus.ControllerStatus = 1) THEN
					MC_Power_0[AxIdx].Enable := 0;
				ELSIF(gAxis[AxIdx].Status.DriveStatus.ControllerStatus = 0) THEN
					AxisStep[AxIdx] := STATE_GLOBAL_INIT;
				END_IF		
							
			(*Ҫλ趨ʼ,˲*)
			STATE_GLOBAL_INIT:
				IF(gAxis[AxIdx].Status.globalInit=1)THEN
					AxisStep[AxIdx] := STATE_INIT_POWER_ON;//Ѿʼֱϵ
				ELSE
					(*Encoder init*)	
					pAxisData.encoder_if.parameter.count_dir				:= gAxis[AxIdx].Parameter.EncoderPara.count_dir;//0---ncSTANDARD 255---ncINVERSE
					pAxisData.encoder_if.parameter.scaling.load.units 		:= gAxis[AxIdx].Parameter.EncoderPara.units;
					pAxisData.encoder_if.parameter.scaling.load.rev_motor 	:= gAxis[AxIdx].Parameter.EncoderPara.rev_motor;

						
					MC_BR_InitAxisPar_0[AxIdx].Execute :=1;
					AxisStep[AxIdx] := STATE_WAIT_GLOBAL_INIT;
				END_IF
			STATE_WAIT_GLOBAL_INIT:
				IF(MC_BR_InitAxisPar_0[AxIdx].Done = TRUE)THEN
					MC_BR_InitAxisPar_0[AxIdx].Execute :=0;
					gAxis[AxIdx].Status.globalInit :=1;
					AxisStep[AxIdx] := STATE_INIT_POWER_ON;//ʼԶϵһ
				END_IF
				IF(MC_BR_InitAxisPar_0[AxIdx].Error=1)THEN
					MC_BR_InitAxisPar_0[AxIdx].Execute :=0;
					gAxis[AxIdx].Status.globalInit :=0;
					gAxis[AxIdx].Error.ErrorID := MC_BR_InitAxisPar_0[AxIdx].ErrorID;
					AxisStep[AxIdx] := STATE_ERROR;
				END_IF
			
			(*****************************INIT POWER ON ****************************)
			(* Switch axis controller on                                       *)
			STATE_INIT_POWER_ON:			
				MC_Power_0[AxIdx].Enable := TRUE;			
				IF (MC_Power_0[AxIdx].Status = TRUE) THEN
					(* ǷMultiԴ*)	
					IF (pAxisData.nc_obj_inf.hardware.acp_typ = ncACP_TYP_PS OR pAxisData.nc_obj_inf.hardware.acp_typ = ncACP_TYP_PPS) THEN
						AxisStep[AxIdx] := STATE_READY;
					ELSE
						AxisStep[AxIdx] := STATE_HOME_DIRECT; //ʼԶ㣬޸
					END_IF
				END_IF
				(* if a power error occured switch off controller *)
				IF (MC_Power_0[AxIdx].Error = TRUE) THEN
					MC_Power_0[AxIdx].Enable := FALSE;
					gAxis[AxIdx].Error.ErrorID := MC_Power_0[AxIdx].ErrorID;
					AxisStep[AxIdx] := STATE_ERROR;
				END_IF 
			//ʵҪ޸ĳʼԭ㷽ʽ
			STATE_HOME_DIRECT:
				MC_Home_0[AxIdx].Position := 0;
				MC_Home_0[AxIdx].HomingMode := mcHOME_DIRECT;
				MC_Home_0[AxIdx].Execute := TRUE;
				IF (MC_Home_0[AxIdx].Done = TRUE) THEN
					MC_Home_0[AxIdx].Execute := FALSE;
					AxisStep[AxIdx] := STATE_READY;
				END_IF   
				(* if a homing error occured go to ready state *)
				IF (MC_Home_0[AxIdx].Error = TRUE) THEN
					MC_Home_0[AxIdx].Execute := FALSE;
					AxisStep[AxIdx] := STATE_READY;
					gAxis[AxIdx].Error.ErrorID := MC_Home_0[AxIdx].ErrorID;
					AxisStep[AxIdx] := STATE_ERROR;
				END_IF
			
			(****************************** READY *******************************)
			(* Wait for Commands                                                *)
			STATE_READY: 
				IF (gAxis[AxIdx].Command.Home = TRUE) THEN
					gAxis[AxIdx].Command.Home := FALSE;
					AxisStep[AxIdx] := STATE_HOME;
				ELSIF((gAxis[AxIdx].Command.Power = TRUE) AND (MC_ReadAxisError_0[AxIdx].Valid = TRUE))THEN
					IF ((MC_ReadStatus_0[AxIdx].Errorstop = TRUE) AND (MC_ReadStatus_0[AxIdx].Valid = TRUE)) THEN
						AxisStep[AxIdx] := STATE_ERROR_RESET;
						gAxis[AxIdx].Command.Power := FALSE;
					ELSE
						AxisStep[AxIdx] := STATE_POWER_ON;
						gAxis[AxIdx].Command.Power := FALSE;
					END_IF
				ELSIF ((gAxis[AxIdx].Command.PowerOff = TRUE) AND (MC_ReadAxisError_0[AxIdx].Valid = TRUE)) THEN
					IF ((MC_ReadStatus_0[AxIdx].Errorstop = TRUE) AND (MC_ReadStatus_0[AxIdx].Valid = TRUE)) THEN
						AxisStep[AxIdx] := STATE_ERROR_RESET;
						gAxis[AxIdx].Command.PowerOff := FALSE;
					ELSE
						AxisStep[AxIdx] := STATE_POWER_OFF;
						gAxis[AxIdx].Command.PowerOff := FALSE;
					END_IF	
				//˶	
				ELSIF (gAxis[AxIdx].Command.MoveJogPos = TRUE) THEN
					AxisStep[AxIdx] := STATE_JOG_POSITIVE;
				ELSIF (gAxis[AxIdx].Command.MoveJogNeg = TRUE) THEN
					AxisStep[AxIdx] := STATE_JOG_NEGATIVE;	
				ELSIF (gAxis[AxIdx].Command.MoveAbsolute = TRUE) THEN
					gAxis[AxIdx].Command.MoveAbsolute := FALSE;
					AxisStep[AxIdx] := STATE_MOVE_ABSOLUTE;
				ELSIF (gAxis[AxIdx].Command.MoveVelocity = TRUE) THEN
					gAxis[AxIdx].Command.MoveVelocity := FALSE;
					AxisStep[AxIdx] := STATE_MOVE_VELOCITY;
				ELSIF(gAxis[AxIdx].Command.MoveVelocityTtiggStop = TRUE)THEN
					gAxis[AxIdx].Command.MoveVelocityTtiggStop := FALSE;
					gAxis[AxIdx].Status.TriggStopOk :=0;//Ѱν־λλ
					AxisStep[AxIdx] := STATE_MOVE_VELOCITY_TRIGGSTOP;	
				ELSIF (gAxis[AxIdx].Command.MoveAdditive = TRUE) THEN
					gAxis[AxIdx].Command.MoveAdditive := FALSE;
					AxisStep[AxIdx] := STATE_MOVE_ADDITIVE;					
				ELSIF (gAxis[AxIdx].Command.Halt = TRUE) THEN
					gAxis[AxIdx].Command.Halt := FALSE;
					AxisStep[AxIdx] := STATE_HALT;										
				ELSIF(gAxis[AxIdx].Command.AutCamInit=1)THEN//͹ֿ
					gAxis[AxIdx].Command.AutCamInit :=0;
					gAxis[AxIdx].Status.AutCamInitOk :=0;
					AxisStep[AxIdx] := STATE_AUTOMAT_INIT;		//͹߳ʼ
				ELSIF(gAxis[AxIdx].Command.AutStartSlave=1)THEN
					gAxis[AxIdx].Command.AutStartSlave :=0;
					AxisStep[AxIdx] := STATE_AUTOMAT_START;		//͹
				ELSIF (gAxis[AxIdx].Command.AutDisengageSlave = TRUE) THEN
					gAxis[AxIdx].Command.AutDisengageSlave := FALSE;
					MC_BR_AutControl_0[AxIdx].Start := FALSE;
					AxisStep[AxIdx] := STATE_AUTOMAT_STOP;				//͹ֽ
				ELSIF gAxis[AxIdx].Command.CamStart	 THEN
					gAxis[AxIdx].Command.CamStart :=0;
					AxisStep[AxIdx] := STATE_CAM_SELECT;
				ELSIF gAxis[AxIdx].Command.CamStop THEN
					gAxis[AxIdx].Command.CamStop := 0;
					IF(gAxis[AxIdx].AxisState.SynchronizedMotion= TRUE)THEN //ֻͬ˶
						AxisStep[AxIdx] := STATE_CAM_STOP;
					END_IF					
				
				ELSIF(gAxis[AxIdx].Command.WriteSingleID=1)THEN			//дID	
					gAxis[AxIdx].Command.WriteSingleID :=0;
					gAxis[AxIdx].Status.WriteSingleID_Ok :=0;
					AxisStep[AxIdx] := STATE_WRITE_PARID;				//дParaID
				
				ELSIF (gAxis[AxIdx].Command.resetGlobalInit = TRUE) THEN  //³ʼ߸λ	
					gAxis[AxIdx].Command.resetGlobalInit := FALSE;
					gAxis[AxIdx].Status.globalInit := FALSE;
					AxisStep[AxIdx] := STATE_INIT_STOP;//³ʼ(ߣ)
					
				END_IF
			
			
			//resetGlobalInitֹͣ˶
			STATE_INIT_STOP:
				IF(    gAxis[AxIdx].AxisState.Disabled =1 
					OR gAxis[AxIdx].AxisState.StandStill=1)THEN
					AxisStep[AxIdx] := STATE_INIT_POWER_OFF;
					
				ELSIF( gAxis[AxIdx].AxisState.Homing =1
					OR gAxis[AxIdx].AxisState.DiscreteMotion =1
					OR gAxis[AxIdx].AxisState.ContinuousMotion =1
					OR gAxis[AxIdx].AxisState.SynchronizedMotion =1)THEN
						
					MC_Stop_0[AxIdx].Deceleration := gAxis[AxIdx].Parameter.Deceleration;
					MC_Stop_0[AxIdx].Execute := TRUE;	
					AxisStep[AxIdx] := STATE_WAIT_INIT_STOP;
				END_IF
			
			STATE_WAIT_INIT_STOP:
				IF (MC_Stop_0[AxIdx].Done = TRUE) THEN
					MC_Stop_0[AxIdx].Execute := FALSE;
					AxisStep[AxIdx] := STATE_INIT_POWER_OFF;
				END_IF   
				(* check if error occured *)
				IF (MC_Stop_0[AxIdx].Error = TRUE) THEN
					MC_Stop_0[AxIdx].Execute := FALSE;
					gAxis[AxIdx].Error.ErrorID := MC_Stop_0[AxIdx].ErrorID;
					AxisStep[AxIdx] := STATE_ERROR;
				END_IF
			//resetGlobalInitʼϵ
			STATE_INIT_POWER_OFF:
				IF(gAxis[AxIdx].Status.DriveStatus.ControllerStatus = FALSE)THEN
					AxisStep[AxIdx] := STATE_WAIT;
				ELSE
					MC_Power_0[AxIdx].Enable := FALSE;
					AxisStep[AxIdx] := STATE_WAIT_INIT_POWER_OFF;
				END_IF
			
			STATE_WAIT_INIT_POWER_OFF:
				IF(gAxis[AxIdx].Status.DriveStatus.ControllerStatus = FALSE)THEN
					AxisStep[AxIdx] := STATE_WAIT;
					ParaTableIndex[AxIdx] := 0;	
				END_IF
				(* if a power error occured switch off controller *)
				IF (MC_Power_0[AxIdx].Error = TRUE) THEN
					MC_Power_0[AxIdx].Enable := FALSE;
					gAxis[AxIdx].Error.ErrorID := MC_Power_0[AxIdx].ErrorID;
					AxisStep[AxIdx] := STATE_ERROR;
				END_IF 
			
			(***************************** POWER ON ****************************)
			(* Switch axis controller on                                       *)
			STATE_POWER_ON:			
				MC_Power_0[AxIdx].Enable := TRUE;			
				IF (MC_Power_0[AxIdx].Status = TRUE) THEN
					(* If power on ok -> go direct to STATE_READY *)	
					AxisStep[AxIdx] := STATE_READY; 
				END_IF
				(* if a power error occured switch off controller *)
				IF (MC_Power_0[AxIdx].Error = TRUE) THEN
					MC_Power_0[AxIdx].Enable := FALSE;
					gAxis[AxIdx].Error.ErrorID := MC_Power_0[AxIdx].ErrorID;
					AxisStep[AxIdx] := STATE_ERROR;
				END_IF 
			(***************************** POWER OFF ****************************)
			(* Switch axis controller off                                       *)
			STATE_POWER_OFF:			
				MC_Power_0[AxIdx].Enable := FALSE;			
				IF (MC_Power_0[AxIdx].Status = FALSE) THEN
					AxisStep[AxIdx] := STATE_READY; 
				END_IF
				(* if a power error occured switch off controller *)
				IF (MC_Power_0[AxIdx].Error = TRUE) THEN
					MC_Power_0[AxIdx].Enable := FALSE;
					gAxis[AxIdx].Error.ErrorID := MC_Power_0[AxIdx].ErrorID;
					AxisStep[AxIdx] := STATE_ERROR;
				END_IF 	
			(****************************** HOME ********************************)
			(* Start homing process                                             *)
			STATE_HOME:
				MC_Home_0[AxIdx].Position := gAxis[AxIdx].Parameter.HomePosition;
				MC_Home_0[AxIdx].HomingMode := gAxis[AxIdx].Parameter.HomeMode;
				MC_Home_0[AxIdx].Execute := TRUE;
				IF (MC_Home_0[AxIdx].Done = TRUE) THEN
					MC_Home_0[AxIdx].Execute := FALSE;
					AxisStep[AxIdx] := STATE_READY;
				END_IF   
				(* if a homing error occured go to ready state *)
				IF (MC_Home_0[AxIdx].Error = TRUE) THEN
					MC_Home_0[AxIdx].Execute := FALSE;
					AxisStep[AxIdx] := STATE_READY;
					gAxis[AxIdx].Error.ErrorID := MC_Home_0[AxIdx].ErrorID;
					AxisStep[AxIdx] := STATE_ERROR;
				END_IF
       
			(*************************** HALT MOVEMENT **************************)
			(* Stop the active movement                                         *)
			STATE_HALT:
				MC_Halt_0[AxIdx].Deceleration := gAxis[AxIdx].Parameter.Deceleration;
				MC_Halt_0[AxIdx].Execute := TRUE;
				IF (MC_Halt_0[AxIdx].Done = TRUE) THEN
					MC_Halt_0[AxIdx].Execute := FALSE;
					AxisStep[AxIdx] := STATE_READY;
				END_IF   
				(* check if error occured *)
				IF ((MC_Halt_0[AxIdx].Error = TRUE) OR (MC_Halt_0[AxIdx].CommandAborted = TRUE)) THEN
					MC_Halt_0[AxIdx].Execute := FALSE;
					gAxis[AxIdx].Error.ErrorID := MC_Halt_0[AxIdx].ErrorID;
					AxisStep[AxIdx] := STATE_ERROR;
				END_IF
       
			(*************************** STOP MOVEMENT **************************)   
			(* Stop movement as long as command is set                          *)
			STATE_STOP:
				MC_Stop_0[AxIdx].Deceleration := gAxis[AxIdx].Parameter.Deceleration;
				MC_Stop_0[AxIdx].Execute := TRUE;
    
				(* if axis is stopped go to ready state *)
				IF (MC_Stop_0[AxIdx].Done = TRUE) THEN
					MC_Stop_0[AxIdx].Execute := FALSE;
					gAxis[AxIdx].Command.Stop:= FALSE;
					AxisStep[AxIdx] := STATE_READY;
				END_IF    
				(* check if error occured *)
				IF (MC_Stop_0[AxIdx].Error = TRUE) THEN
					MC_Stop_0[AxIdx].Execute := FALSE;
					gAxis[AxIdx].Error.ErrorID := MC_Stop_0[AxIdx].ErrorID;
					AxisStep[AxIdx] := STATE_ERROR;
				END_IF				
				(* reset all pendig commands *)
				gAxis[AxIdx].Command.MoveAbsolute 	:= FALSE;
				gAxis[AxIdx].Command.Home 			:= FALSE;
				gAxis[AxIdx].Command.MoveAdditive 	:= FALSE;
				gAxis[AxIdx].Command.MoveVelocity 	:= FALSE;
				gAxis[AxIdx].Command.MoveJogPos 	:= FALSE;
				gAxis[AxIdx].Command.MoveJogNeg 	:= FALSE;
				gAxis[AxIdx].Command.resetGlobalInit := FALSE;
				
				gAxis[AxIdx].Command.AutCamInit		:= FALSE;				
				gAxis[AxIdx].Command.AutStartSlave 	:= FALSE;
				gAxis[AxIdx].Command.AutDisengageSlave 	:= FALSE;			
				gAxis[AxIdx].Command.Signal1 		:= FALSE;
				gAxis[AxIdx].Command.Signal2 		:= FALSE;
				gAxis[AxIdx].Command.Signal3 		:= FALSE;
				gAxis[AxIdx].Command.Signal4 		:= FALSE;
			
			(******************** START JOG MOVEMENT POSITVE **********************)
			STATE_JOG_POSITIVE:  (* STATE: Start jog movement in positive direction *)							
				MC_MoveVelocity_0[AxIdx].Velocity      := gAxis[AxIdx].Parameter.JogVelocity;
				MC_MoveVelocity_0[AxIdx].Acceleration  := gAxis[AxIdx].Parameter.Acceleration;
				MC_MoveVelocity_0[AxIdx].Deceleration  := gAxis[AxIdx].Parameter.Deceleration;
				MC_MoveVelocity_0[AxIdx].Direction     := mcPOSITIVE_DIR;
				MC_MoveVelocity_0[AxIdx].Execute       := 1;
				
				IF (gAxis[AxIdx].Command.MoveJogPos = FALSE) THEN
					MC_MoveVelocity_0[AxIdx].Execute := 0;
					AxisStep[AxIdx] := STATE_HALT;
				END_IF
				(* check if error occured *)
				IF (MC_MoveVelocity_0[AxIdx].Error = TRUE) THEN
					MC_MoveVelocity_0[AxIdx].Execute := FALSE;
					gAxis[AxIdx].Error.ErrorID := MC_MoveVelocity_0[AxIdx].ErrorID;
					AxisStep[AxIdx] := STATE_ERROR;
				END_IF
				
			(******************** START JOG MOVEMENT NEGATIVE **********************)
			STATE_JOG_NEGATIVE:  (* STATE: Start jog movement in negative direction *)				
				MC_MoveVelocity_0[AxIdx].Velocity      := gAxis[AxIdx].Parameter.JogVelocity;
				MC_MoveVelocity_0[AxIdx].Acceleration  := gAxis[AxIdx].Parameter.Acceleration;
				MC_MoveVelocity_0[AxIdx].Deceleration  := gAxis[AxIdx].Parameter.Deceleration;
				MC_MoveVelocity_0[AxIdx].Direction     := mcNEGATIVE_DIR;
				MC_MoveVelocity_0[AxIdx].Execute       := 1;
				
				IF (gAxis[AxIdx].Command.MoveJogNeg = FALSE) THEN
					MC_MoveVelocity_0[AxIdx].Execute := 0;
					AxisStep[AxIdx] := STATE_HALT;
				END_IF
				(* check if error occured *)
				IF (MC_MoveVelocity_0[AxIdx].Error = TRUE) THEN
					MC_MoveVelocity_0[AxIdx].Execute := FALSE;
					gAxis[AxIdx].Error.ErrorID := MC_MoveVelocity_0[AxIdx].ErrorID;
					AxisStep[AxIdx] := STATE_ERROR;
				END_IF
				
			(********************* START ABSOLUTE MOVEMENT **********************)
			(* Start absolute movement                                          *)
			STATE_MOVE_ABSOLUTE:
				MC_MoveAbsolute_0[AxIdx].Direction     := 0;
				MC_MoveAbsolute_0[AxIdx].Position      := gAxis[AxIdx].Parameter.Position;
				MC_MoveAbsolute_0[AxIdx].Velocity      := gAxis[AxIdx].Parameter.Velocity;
				MC_MoveAbsolute_0[AxIdx].Acceleration  := gAxis[AxIdx].Parameter.Acceleration;
				MC_MoveAbsolute_0[AxIdx].Deceleration  := gAxis[AxIdx].Parameter.Deceleration;
				MC_MoveAbsolute_0[AxIdx].Direction     := gAxis[AxIdx].Parameter.Direction;
				MC_MoveAbsolute_0[AxIdx].Execute       := 1;
    
				IF (gAxis[AxIdx].Command.Halt = TRUE) THEN
					gAxis[AxIdx].Command.Halt := 0;
					MC_MoveAbsolute_0[AxIdx].Execute := 0;
					AxisStep[AxIdx] := STATE_HALT;
				ELSIF (MC_MoveAbsolute_0[AxIdx].Done = TRUE) THEN
					MC_MoveAbsolute_0[AxIdx].Execute := FALSE;
					AxisStep[AxIdx] := STATE_READY;
				END_IF
    
				IF (MC_MoveAbsolute_0[AxIdx].Error = TRUE) THEN
					MC_MoveAbsolute_0[AxIdx].Execute := FALSE;
					gAxis[AxIdx].Error.ErrorID := MC_MoveAbsolute_0[AxIdx].ErrorID;
					AxisStep[AxIdx] := STATE_ERROR;
				END_IF
    
			(********************* START ABSOLUTE VELOCITY **********************)
			(* Start velocity movement  ,the axis must be home.when the override is not 1.0 ,the signal Invelocity will not be set   *)
			STATE_MOVE_VELOCITY:
				MC_MoveVelocity_0[AxIdx].Velocity      := gAxis[AxIdx].Parameter.Velocity;
				MC_MoveVelocity_0[AxIdx].Acceleration  := gAxis[AxIdx].Parameter.Acceleration;
				MC_MoveVelocity_0[AxIdx].Deceleration  := gAxis[AxIdx].Parameter.Deceleration;
				MC_MoveVelocity_0[AxIdx].Direction     := gAxis[AxIdx].Parameter.Direction;
				MC_MoveVelocity_0[AxIdx].Execute       := 1;
    
				IF (gAxis[AxIdx].Command.Halt = TRUE) THEN
					gAxis[AxIdx].Command.Halt := 0;
					MC_MoveVelocity_0[AxIdx].Execute := 0;
					AxisStep[AxIdx] := STATE_HALT;
				ELSIF(MC_MoveVelocity_0[AxIdx].InVelocity) THEN
					MC_MoveVelocity_0[AxIdx].Execute := 0;
					AxisStep[AxIdx] := STATE_READY; (*the set velocity reached ,it goto STATE_READY step*)
				END_IF   
				IF (MC_MoveVelocity_0[AxIdx].Error = TRUE) THEN
					MC_MoveVelocity_0[AxIdx].Execute := FALSE;
					gAxis[AxIdx].Error.ErrorID := MC_MoveVelocity_0[AxIdx].ErrorID;
					AxisStep[AxIdx] := STATE_ERROR;
				END_IF
			
			(********************* START VELOCITY TRIGGSTOP **********************)
			(* Start velocity trigg stop                                          *)
			STATE_MOVE_VELOCITY_TRIGGSTOP:
				//Ѱβ߼и
				MC_BR_MoveVelocityTriggStop_0[AxIdx].Velocity      				:= gAxis[AxIdx].Parameter.TriggerStopPra.Velocity;
				MC_BR_MoveVelocityTriggStop_0[AxIdx].Acceleration  				:= gAxis[AxIdx].Parameter.TriggerStopPra.Acceleration;
				MC_BR_MoveVelocityTriggStop_0[AxIdx].Deceleration  				:= gAxis[AxIdx].Parameter.TriggerStopPra.Deceleration;				
				MC_BR_MoveVelocityTriggStop_0[AxIdx].Direction     				:= gAxis[AxIdx].Parameter.TriggerStopPra.Direction;//mcPOSITIVE_DIR//mcNEGATIVE_DIR
				MC_BR_MoveVelocityTriggStop_0[AxIdx].TriggerDistance 			:= gAxis[AxIdx].Parameter.TriggerStopPra.TriggerDistance;
				MC_BR_MoveVelocityTriggStop_0[AxIdx].TriggerInput.InputSource 	:= gAxis[AxIdx].Parameter.TriggerStopPra.TriggerInput.InputSource;//ncTRIGGER1 / ncTRIGGER2
				MC_BR_MoveVelocityTriggStop_0[AxIdx].TriggerInput.Edge			:= gAxis[AxIdx].Parameter.TriggerStopPra.TriggerInput.Edge;//ncP_EDGE / ncN_EDGE
				MC_BR_MoveVelocityTriggStop_0[AxIdx].Execute       				:= 1;
    
				IF (gAxis[AxIdx].Command.Halt = TRUE) THEN
					gAxis[AxIdx].Command.Halt := 0;
					MC_BR_MoveVelocityTriggStop_0[AxIdx].Execute := 0;
					AxisStep[AxIdx] := STATE_HALT;
				ELSIF(MC_BR_MoveVelocityTriggStop_0[AxIdx].Done=1)THEN
					MC_BR_MoveVelocityTriggStop_0[AxIdx].Execute := 0;
					gAxis[AxIdx].Status.TriggStopOk :=1;//Ѱν־λ
					AxisStep[AxIdx] := STATE_READY;
				END_IF   
				IF (MC_BR_MoveVelocityTriggStop_0[AxIdx].Error = TRUE) THEN
					MC_BR_MoveVelocityTriggStop_0[AxIdx].Execute := FALSE;
					gAxis[AxIdx].Error.ErrorID := MC_BR_MoveVelocityTriggStop_0[AxIdx].ErrorID;
					AxisStep[AxIdx] := STATE_ERROR;
				END_IF
			(********************* START ADDITIVE MOVEMENT **********************)
			(* Start additive movement                                          *)
			STATE_MOVE_ADDITIVE:
				MC_MoveAdditive_0[AxIdx].Distance      := gAxis[AxIdx].Parameter.Distance;
				MC_MoveAdditive_0[AxIdx].Velocity      := gAxis[AxIdx].Parameter.Velocity;
				MC_MoveAdditive_0[AxIdx].Acceleration  := gAxis[AxIdx].Parameter.Acceleration;
				MC_MoveAdditive_0[AxIdx].Deceleration  := gAxis[AxIdx].Parameter.Deceleration;
				MC_MoveAdditive_0[AxIdx].Execute       := 1;
    
				IF (gAxis[AxIdx].Command.Halt = TRUE) THEN
					gAxis[AxIdx].Command.Halt := 0;
					MC_MoveAdditive_0[AxIdx].Execute := 0;
					AxisStep[AxIdx] := STATE_HALT;
				ELSIF (MC_MoveAdditive_0[AxIdx].Done = TRUE) THEN
					MC_MoveAdditive_0[AxIdx].Execute := FALSE;
					AxisStep[AxIdx] := STATE_READY;
				END_IF
    
				IF (MC_MoveAdditive_0[AxIdx].Error = TRUE) THEN
					MC_MoveAdditive_0[AxIdx].Execute := FALSE;
					gAxis[AxIdx].Error.ErrorID := MC_MoveAdditive_0[AxIdx].ErrorID;
					AxisStep[AxIdx] := STATE_ERROR;
				END_IF
			
			//͹߳ʼ
			STATE_AUTOMAT_INIT:				
				//AutData  ɼܳAtuomatData 				
				MC_BR_AutControl_0[AxIdx].Enable 		:= 1;
				MC_BR_AutControl_0[AxIdx].AdrAutData 	:= ADR(AutData[AxIdx]);
				MC_BR_AutControl_0[AxIdx].InitAutData 	:= 1;
		
				IF(MC_BR_AutControl_0[AxIdx].AutDataInitialized=1)THEN
					MC_BR_AutControl_0[AxIdx].InitAutData 	:= 0;
					gAxis[AxIdx].Status.AutCamInitOk		:= 1;//سɹ־λ
					AxisStep[AxIdx] := STATE_READY;
				END_IF
				
				(*check if error occured *)
				IF (MC_BR_AutControl_0[AxIdx].Error = TRUE ) THEN
					MC_BR_AutControl_0[AxIdx].Enable := FALSE;
					MC_BR_AutControl_0[AxIdx].Start := 0;
					gAxis[AxIdx].Error.ErrorID := MC_BR_AutControl_0[AxIdx].ErrorID;
					AxisStep[AxIdx] := STATE_ERROR;
				END_IF
							
			STATE_AUTOMAT_START:
				MC_BR_AutControl_0[AxIdx].Enable := TRUE;
				MC_BR_AutControl_0[AxIdx].Start := TRUE;
			
				(* wait for Automat stop *)
				IF (gAxis[AxIdx].Command.Stop = TRUE) THEN
					MC_BR_AutControl_0[AxIdx].Enable := FALSE;
					MC_BR_AutControl_0[AxIdx].Start := FALSE;
					AxisStep[AxIdx] := STATE_STOP;
				ELSIF (gAxis[AxIdx].Command.Halt = TRUE) THEN
					gAxis[AxIdx].Command.Halt := FALSE;
					MC_BR_AutControl_0[AxIdx].Enable := FALSE;
					MC_BR_AutControl_0[AxIdx].Start := FALSE;
					AxisStep[AxIdx] := STATE_HALT;							
				ELSIF (MC_BR_AutControl_0[AxIdx].Running = TRUE) THEN
					AxisStep[AxIdx] := STATE_READY;//͹ּ󷵻صSTATE_READYԽָ
				END_IF
				(* check if error occured *)
				IF (MC_BR_AutControl_0[AxIdx].Error = TRUE) THEN
					MC_BR_AutControl_0[AxIdx].Enable := FALSE;
					MC_BR_AutControl_0[AxIdx].Start := FALSE;
					gAxis[AxIdx].Error.ErrorID := MC_BR_AutControl_0[AxIdx].ErrorID;
					AxisStep[AxIdx] := STATE_ERROR;
				END_IF
			STATE_AUTOMAT_STOP:
				MC_BR_AutControl_0[AxIdx].Deceleration := gAxis[AxIdx].Parameter.Deceleration;
				MC_BR_AutControl_0[AxIdx].Stop := TRUE;
				(* check if automat is stopped *)
				IF (MC_BR_AutControl_0[AxIdx].Running = FALSE) THEN
					MC_BR_AutControl_0[AxIdx].Enable := FALSE;
					MC_BR_AutControl_0[AxIdx].Stop := FALSE;
					AxisStep[AxIdx] := STATE_READY;
				END_IF
				(* check if error occured *)
				IF (MC_BR_AutControl_0[AxIdx].Error = TRUE) THEN
					MC_BR_AutControl_0[AxIdx].Enable := FALSE;
					MC_BR_AutControl_0[AxIdx].Stop := FALSE;
					gAxis[AxIdx].Error.ErrorID := MC_BR_AutControl_0[AxIdx].ErrorID;
					AxisStep[AxIdx] := STATE_ERROR;
				END_IF
			//CamInʹCamSelectʹõĲĵһ
			STATE_CAM_SELECT:
				brsstrcpy(ADR(MC_CamTableSelect_0[AxIdx].CamTable),ADR(gAxis[AxIdx].Parameter.camProfileName[0]));
				MC_CamTableSelect_0[AxIdx].Periodic := mcPERIODIC;
				MC_CamTableSelect_0[AxIdx].Execute 	:= 1;
				
				IF MC_CamTableSelect_0[AxIdx].Done = 1 THEN
					MC_CamTableSelect_0[AxIdx].Execute 	:= 0;
					CamTableID[AxIdx] :=MC_CamTableSelect_0[AxIdx].CamTableID;
					AxisStep[AxIdx] := STATE_CAM_START;
				ELSIF MC_CamTableSelect_0[AxIdx].Error = 1 THEN
					MC_CamTableSelect_0[AxIdx].Execute 	:= 0;
					gAxis[AxIdx].Error.ErrorID :=MC_CamTableSelect_0[AxIdx].ErrorID;
					AxisStep[AxIdx] := STATE_ERROR;
				END_IF
			//camProfile
			STATE_CAM_START:
				MC_CamIn_0[AxIdx].MasterOffset 	:= gAxis[AxIdx].Parameter.CamPara.MasterOffset;
				MC_CamIn_0[AxIdx].SlaveOffset 	:= gAxis[AxIdx].Parameter.CamPara.SlaveOffset;
				MC_CamIn_0[AxIdx].MasterScaling := gAxis[AxIdx].Parameter.CamPara.MasterScaling;
				MC_CamIn_0[AxIdx].SlaveScaling 	:= gAxis[AxIdx].Parameter.CamPara.SlaveScaling;
				MC_CamIn_0[AxIdx].StartMode 	:= gAxis[AxIdx].Parameter.CamPara.StartMode;
				MC_CamIn_0[AxIdx].CamTableID 	:= CamTableID[AxIdx];
				MC_CamIn_0[AxIdx].Execute       := 1;
			
				IF gAxis[AxIdx].Command.Halt = 1 THEN
					gAxis[AxIdx].Command.Halt 	:= 0;
					MC_CamIn_0[AxIdx].Execute 	:= 0;
					AxisStep[AxIdx] 			:= STATE_HALT;
				ELSIF MC_CamIn_0[AxIdx].InSync = 1 THEN
					MC_CamIn_0[AxIdx].Execute 	:= 0;
					AxisStep[AxIdx] 			:= STATE_READY;
				END_IF
				
				IF MC_CamIn_0[AxIdx].Error  = 1 THEN
					MC_CamIn_0[AxIdx].Execute 	:= 0;
					gAxis[AxIdx].Error.ErrorID 	:= MC_CamIn_0[AxIdx].ErrorID;
					AxisStep[AxIdx] 			:= STATE_ERROR;
				END_IF
			
			STATE_CAM_STOP:
				MC_CamOut_0[AxIdx].Execute 		:= 1; 
				IF MC_CamOut_0[AxIdx].Done = 1 THEN
					MC_CamOut_0[AxIdx].Execute 	:= 0;
					AxisStep[AxIdx] 			:= STATE_READY;
				END_IF
			
				IF MC_CamOut_0[AxIdx].Error = 1 THEN
					MC_CamOut_0[AxIdx].Execute 	:= 0;
					gAxis[AxIdx].Error.ErrorID 	:= MC_CamOut_0[AxIdx].ErrorID;
					AxisStep[AxIdx] 			:= STATE_ERROR;
				END_IF
			
			STATE_WRITE_PARID:
				//߼иID,õ(0,1,2,3,4)ַ				
				MC_BR_WriteParID_0[AxIdx].ParID 		:= gAxis[AxIdx].Parameter.WriteSingleID.paraID;
														//gAxis[AxIdx].Parameter.WriteSingleID.datatype//߼ͬʱID				
				CASE (gAxis[AxIdx].Parameter.WriteSingleID.datatype) OF
					ncPAR_TYP_DINT://4
						MC_BR_WriteParID_0[AxIdx].DataType 		:= ncPAR_TYP_DINT;
						MC_BR_WriteParID_0[AxIdx].DataAddress 	:= ADR(gAxis[AxIdx].Parameter.WriteSingleID.I4);
					ncPAR_TYP_USINT://5
						MC_BR_WriteParID_0[AxIdx].DataType 		:= ncPAR_TYP_USINT;
						MC_BR_WriteParID_0[AxIdx].DataAddress 	:= ADR(gAxis[AxIdx].Parameter.WriteSingleID.UI1);
					ncPAR_TYP_UINT://6
						MC_BR_WriteParID_0[AxIdx].DataType 		:= ncPAR_TYP_UINT;
						MC_BR_WriteParID_0[AxIdx].DataAddress 	:= ADR(gAxis[AxIdx].Parameter.WriteSingleID.UI2);
					ncPAR_TYP_UDINT://7
						MC_BR_WriteParID_0[AxIdx].DataType 		:= ncPAR_TYP_UDINT;
						MC_BR_WriteParID_0[AxIdx].DataAddress 	:= ADR(gAxis[AxIdx].Parameter.WriteSingleID.UI4);
					ncPAR_TYP_REAL:	//8
						MC_BR_WriteParID_0[AxIdx].DataType 		:= ncPAR_TYP_REAL;
						MC_BR_WriteParID_0[AxIdx].DataAddress 	:= ADR(gAxis[AxIdx].Parameter.WriteSingleID.R4);
				END_CASE
				
				MC_BR_WriteParID_0[AxIdx].Execute			:=1;
				IF(MC_BR_WriteParID_0[AxIdx].Done=1)THEN
					MC_BR_WriteParID_0[AxIdx].Execute		:=0;
					gAxis[AxIdx].Status.WriteSingleID_Ok 	:=1;
					AxisStep[AxIdx] := STATE_READY;
				END_IF
				(* check if error occured *)
				IF (MC_BR_WriteParID_0[AxIdx].Error = TRUE) THEN					
					MC_BR_WriteParID_0[AxIdx].Execute		:=0;
					gAxis[AxIdx].Error.ErrorID := MC_BR_WriteParID_0[AxIdx].ErrorID;
					AxisStep[AxIdx] := STATE_ERROR;
				END_IF
			
			(******************** FB-ERROR OCCURED *************************)
			STATE_ERROR: (* STATE: Error *)
				(* check if FB indicates an axis error *)
				(*MC_ReadAxisError_0.AxisErrorCount =Number of unacknowledged axis errors*)
				IF (MC_ReadAxisError_0[AxIdx].AxisErrorCount<>0) THEN
					AxisStep[AxIdx] := STATE_ERROR_AXIS;
				ELSE	
					
					IF (gAxis[AxIdx].Command.ErrorAcknowledge = TRUE) THEN
						gAxis[AxIdx].Command.ErrorAcknowledge := FALSE;
						gAxis[AxIdx].Error.ErrorID := 0;
						(* reset axis if it is in axis state ErrorStop *)
						IF ((MC_ReadStatus_0[AxIdx].Errorstop = TRUE) AND (MC_ReadStatus_0[AxIdx].Valid = TRUE)) THEN
							AxisStep[AxIdx] := STATE_ERROR_RESET;
						ELSE
							AxisStep[AxIdx] := STATE_WAIT; //ܿĻλֱӽSTATEREADYȴ״̬
						END_IF
					END_IF
				END_IF
			
			(******************** STATE_ERROR_STOP *************************)
			STATE_ERROR_STOP:
				MC_Stop_0[AxIdx].Deceleration 	:= gAxis[AxIdx].Parameter.Deceleration;
				MC_Stop_0[AxIdx].Execute 		:= TRUE;    
				(* if axis is stopped go to STATE_ERROR state *)
				IF (MC_Stop_0[AxIdx].Done = TRUE) THEN
					MC_Stop_0[AxIdx].Execute := FALSE;
					AxisStep[AxIdx] := STATE_ERROR;
				END_IF    
				(* check if error occured *)
				IF (MC_Stop_0[AxIdx].Error = TRUE) THEN
					MC_Stop_0[AxIdx].Execute := FALSE;
					gAxis[AxIdx].Error.ErrorID := MC_Stop_0[AxIdx].ErrorID;
					AxisStep[AxIdx] := STATE_ERROR;
				END_IF				
				(* reset all pendig commands *)
				gAxis[AxIdx].Command.MoveAbsolute 	:= FALSE;
				gAxis[AxIdx].Command.Home 			:= FALSE;
				gAxis[AxIdx].Command.MoveAdditive 	:= FALSE;
				gAxis[AxIdx].Command.MoveVelocity 	:= FALSE;
				gAxis[AxIdx].Command.MoveJogPos 	:= FALSE;
				gAxis[AxIdx].Command.MoveJogNeg 	:= FALSE;
				gAxis[AxIdx].Command.resetGlobalInit := FALSE;				
				gAxis[AxIdx].Command.AutCamInit		:= FALSE;				
				gAxis[AxIdx].Command.AutStartSlave 	:= FALSE;
				gAxis[AxIdx].Command.AutDisengageSlave 	:= FALSE;			
				gAxis[AxIdx].Command.Signal1 		:= FALSE;
				gAxis[AxIdx].Command.Signal2 		:= FALSE;
				gAxis[AxIdx].Command.Signal3 		:= FALSE;
				gAxis[AxIdx].Command.Signal4 		:= FALSE;
			
			(******************** AXIS-ERROR OCCURED *************************)
			STATE_ERROR_AXIS: (* STATE: Axis Error *)
				IF (MC_ReadAxisError_0[AxIdx].Valid = TRUE) THEN
					IF (MC_ReadAxisError_0[AxIdx].AxisErrorID <> 0) THEN
						gAxis[AxIdx].Error.ErrorID := MC_ReadAxisError_0[AxIdx].AxisErrorID;
					END_IF
					MC_ReadAxisError_0[AxIdx].Acknowledge := FALSE;
				
					IF (gAxis[AxIdx].Command.ErrorAcknowledge = TRUE) THEN
						gAxis[AxIdx].Command.ErrorAcknowledge := FALSE;
						(* acknowledge axis error *)
						IF (MC_ReadAxisError_0[AxIdx].AxisErrorID <> 0) THEN
							MC_ReadAxisError_0[AxIdx].Acknowledge := TRUE;
						END_IF
					END_IF
					IF (MC_ReadAxisError_0[AxIdx].AxisErrorCount = 0) THEN
						(* reset axis if it is in axis state ErrorStop *)
						gAxis[AxIdx].Error.ErrorID := 0;
						IF ((MC_ReadStatus_0[AxIdx].Errorstop = TRUE) AND (MC_ReadStatus_0[AxIdx].Valid = TRUE)) THEN
							AxisStep[AxIdx] := STATE_ERROR_RESET;
						ELSE
							AxisStep[AxIdx] := STATE_WAIT;
						END_IF
					END_IF
				END_IF

			(******************** RESET DONE *************************)
			STATE_ERROR_RESET: (* STATE: Wait for reset done *)
				MC_Reset_0[AxIdx].Execute := TRUE;
				(* reset MC_Power.Enable if this FB is in Error*)
				IF (MC_Power_0[AxIdx].Error = TRUE) THEN
					MC_Power_0[AxIdx].Enable := FALSE;
				END_IF
				IF(MC_Reset_0[AxIdx].Done = TRUE)THEN
					MC_Reset_0[AxIdx].Execute := FALSE;
					AxisStep[AxIdx] := STATE_WAIT;
				ELSIF(MC_Reset_0[AxIdx].Error = TRUE) THEN
					MC_Reset_0[AxIdx].Execute := FALSE;
					AxisStep[AxIdx] := STATE_ERROR;                    
				END_IF
								
		END_CASE
		(*********************** SEQUENCE END *******************************)
		
		
		(*********************************************************************
					FUNCTION Block Calls
		*********************************************************************)	   
		(*************************** MC_POWER *******************************)
		MC_Power_0[AxIdx].Axis := gAxisRef[AxIdx];
		MC_Power_0[AxIdx]();
    
		(**************************** MC_HOME *******************************)
		MC_Home_0[AxIdx].Axis := gAxisRef[AxIdx];
		MC_Home_0[AxIdx]();
    
		(************************ MC_MOVEABSOLUTE ***************************)
		MC_MoveAbsolute_0[AxIdx].Axis := gAxisRef[AxIdx];
		MC_MoveAbsolute_0[AxIdx]();
		
		(********************** MC_MOVEADDITIVE *************************)
		MC_MoveAdditive_0[AxIdx].Axis := gAxisRef[AxIdx];
		MC_MoveAdditive_0[AxIdx]();

		(********************** MC_MOVEVELOCITY *************************)
		MC_MoveVelocity_0[AxIdx].Axis := gAxisRef[AxIdx];
		MC_MoveVelocity_0[AxIdx]();
		
		(********************** MC_BR_MoveVelocityTriggStop *************************)
		MC_BR_MoveVelocityTriggStop_0[AxIdx].Axis := gAxisRef[AxIdx];
		MC_BR_MoveVelocityTriggStop_0[AxIdx]();
		(**************************** MC_STOP *******************************)
		MC_Stop_0[AxIdx].Axis := gAxisRef[AxIdx];
		MC_Stop_0[AxIdx]();
    
		(****************************MC_HALT*********************************)
		MC_Halt_0[AxIdx].Axis := gAxisRef[AxIdx];
		MC_Halt_0[AxIdx]();
		
		(****************************MC_BR_InitParTabObj*********************************)
		MC_BR_InitParTabObj_0[AxIdx].Axis := gAxisRef[AxIdx];
		MC_BR_InitParTabObj_0[AxIdx]();
		
		(****************************MC_BR_DownloadCamProfileObj*********************************)
		MC_BR_DownloadCamProfileObj_0[AxIdx].Axis := gAxisRef[AxIdx];
		MC_BR_DownloadCamProfileObj_0[AxIdx]();
		
		(****************************MC_BR_InitAxisPar*********************************)
		MC_BR_InitAxisPar_0[AxIdx].Axis := gAxisRef[AxIdx];
		MC_BR_InitAxisPar_0[AxIdx]();
		
		(****************************MC_BR_WriteParID_0*********************************)
		MC_BR_WriteParID_0[AxIdx].Axis := gAxisRef[AxIdx];
		MC_BR_WriteParID_0[AxIdx]();
		
		(***************************MC_CamTableSelect_0*********************************)
		MC_CamTableSelect_0[AxIdx].Slave := gAxisRef[AxIdx];
		MC_CamTableSelect_0[AxIdx]();
		
		(**************************MC_CamIn_0*******************************************)
		MC_CamIn_0[AxIdx].Slave := gAxisRef[AxIdx];
		MC_CamIn_0[AxIdx]();
		
		(**************************MC_CamOut_0******************************************)
		MC_CamOut_0[AxIdx].Slave := gAxisRef[AxIdx];
		MC_CamOut_0[AxIdx]();
		
		(********************** MC_BR_AutControl*************************)
		MC_BR_AutControl_0[AxIdx].Slave := gAxisRef[AxIdx];
		MC_BR_AutControl_0[AxIdx].Signal1	:= gAxis[AxIdx].Command.Signal1;
		MC_BR_AutControl_0[AxIdx].Signal2	:= gAxis[AxIdx].Command.Signal2;
		MC_BR_AutControl_0[AxIdx].Signal3	:= gAxis[AxIdx].Command.Signal3;
		MC_BR_AutControl_0[AxIdx].Signal4	:= gAxis[AxIdx].Command.Signal4;
		MC_BR_AutControl_0[AxIdx]();
		gAxis[AxIdx].Status.ActualStateIndex := MC_BR_AutControl_0[AxIdx].ActualStateIndex;
		
		(********************** MC_SetOverride*************************)
		MC_SetOverride_0[AxIdx].Enable		:= NOT(MC_ReadStatus_0[AxIdx].StandStill);
		MC_SetOverride_0[AxIdx].VelFactor	:= gAxis[AxIdx].Parameter.V_Override;
		MC_SetOverride_0[AxIdx].AccFactor	:= gAxis[AxIdx].Parameter.A_Override;
		MC_SetOverride_0[AxIdx].Axis		:= gAxisRef[AxIdx];
		MC_SetOverride_0[AxIdx]();
		
		(************************** MC_RESET ****************************)
		MC_Reset_0[AxIdx].Axis := gAxisRef[AxIdx];
		MC_Reset_0[AxIdx]();
		
		
			
		(***************************** ϵ,ȡ¶,,DCѹ ****************************)
		//ID381¶
		MC_BR_InitCyclicRead_1[AxIdx].Enable			:= NOT(MC_BR_InitCyclicRead_1[AxIdx].Error);
		MC_BR_InitCyclicRead_1[AxIdx].ParID				:= ACP10PAR_TEMP_MOTOR;
		MC_BR_InitCyclicRead_1[AxIdx].DataAddress		:= ADR(gAxis[AxIdx].Status.ActMotorTemperature);
		MC_BR_InitCyclicRead_1[AxIdx].DataType			:= ncPAR_TYP_REAL;
		//ID214ӵ
		MC_BR_InitCyclicRead_2[AxIdx].Enable			:= NOT(MC_BR_InitCyclicRead_2[AxIdx].Error);
		MC_BR_InitCyclicRead_2[AxIdx].ParID				:= ACP10PAR_ICTRL_ISQ_ACT;
		MC_BR_InitCyclicRead_2[AxIdx].DataAddress		:= ADR(gAxis[AxIdx].Status.ActCurrent);
		MC_BR_InitCyclicRead_2[AxIdx].DataType			:= ncPAR_TYP_REAL;
		//ID298ʵֱĸߵѹ
		MC_BR_InitCyclicRead_3[AxIdx].Enable			:= NOT(MC_BR_InitCyclicRead_3[AxIdx].Error);
		MC_BR_InitCyclicRead_3[AxIdx].ParID				:= ACP10PAR_UDC_ACT;
		MC_BR_InitCyclicRead_3[AxIdx].DataAddress		:= ADR(gAxis[AxIdx].Status.ActDCVoltage);
		MC_BR_InitCyclicRead_3[AxIdx].DataType			:= ncPAR_TYP_REAL;
		
		(********************** MC_BR_CyclicRead*************************)
		MC_BR_InitCyclicRead_1[AxIdx].Axis	:= gAxisRef[AxIdx];
		MC_BR_InitCyclicRead_1[AxIdx]();
		MC_BR_InitCyclicRead_2[AxIdx].Axis	:= gAxisRef[AxIdx];
		MC_BR_InitCyclicRead_2[AxIdx]();
		MC_BR_InitCyclicRead_3[AxIdx].Axis	:= gAxisRef[AxIdx];
		MC_BR_InitCyclicRead_3[AxIdx]();
		
		(********************** MC_BR_CyclicWrite*************************)
		MC_BR_InitCyclicWrite_0[AxIdx].Axis	:= gAxisRef[AxIdx];
		MC_BR_InitCyclicWrite_0[AxIdx]();
	
		
		
		//㾲
		IF(ABS(gAxis[AxIdx].Status.ActCurrent)>ABS(gAxis[AxIdx].Status.MaxCurrent))THEN
			gAxis[AxIdx].Status.MaxCurrent := gAxis[AxIdx].Status.ActCurrent;
		END_IF
		//ߵѹ
		gAxis[AxIdx].Status.ActACLine	:= gAxis[AxIdx].Status.ActDCVoltage/1.41421356;			
		(********************** Global MonitorλListBoxѡʾǸĲ*************************)
		gGlobalAxesMonitor.ActPosition 			:= gAxis[HmiAxisMonitorIndex].Status.ActPosition;
		gGlobalAxesMonitor.ActRpm 				:= gAxis[HmiAxisMonitorIndex].Status.ActRpm;		
		gGlobalAxesMonitor.ActCurrent			:= gAxis[HmiAxisMonitorIndex].Status.ActCurrent/1.414;//ʵʵID214/1.414м
		gGlobalAxesMonitor.MaxCurrent 			:= gAxis[HmiAxisMonitorIndex].Status.MaxCurrent/1.414;
		gGlobalAxesMonitor.ActTorque 			:= gAxis[HmiAxisMonitorIndex].Status.ActTorque;
		gGlobalAxesMonitor.ActDCVoltage			:= gAxis[HmiAxisMonitorIndex].Status.ActDCVoltage;
		gGlobalAxesMonitor.ActACLine 			:= gAxis[HmiAxisMonitorIndex].Status.ActACLine;
		gGlobalAxesMonitor.ActMotorTemperature 	:= gAxis[HmiAxisMonitorIndex].Status.ActMotorTemperature;
				
	
	END_FOR;

END_PROGRAM
